----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
-----------    PKBlow by Pakze - Ahn'qiraj  					------------------------
-----------    Version 1.09										------------------------
-----------    This addon tracks your pvp killing blows		    ------------------------
----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------

-- make sure LibStub is loaded
if not LibStub then
	print("PKBlow requires LibStub.")
	return
end

----------------------------------------------------------------------------------------
-----------------------------[[  local variables  ]]------------------------------------
----------------------------------------------------------------------------------------

-- create local namespace
local PKBlow = {}
_G.PKBlow = PKBlow

local addonname, addon = ...
local L = LibStub("AceLocale-3.0"):GetLocale("PKBlow", false)
local LDB = LibStub("LibDataBroker-1.1", true)
local PKBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local version = GetAddOnMetadata("PKBlow", "Version")
local pkblocale = GetLocale()
local soundpath = "Interface\\AddOns\\PKBlow\\Sounds\\"
local fontpath = "Interface\\AddOns\\PKBlow\\Fonts\\"
local locDB = {
	maxrows = 3,
	maxentries = 22,
	height = 18,
	petGuid = {},
	bool = {
		getrealm = false,
		realmset = false,
		splayer = false,
		class = false,
		ksorted = false,
		tksorted = false,
	},
	const = {
		MAXLINES = 25,					-- maximum of 25 lines per page
		nme = 1,
		class = 2,
		kills = 3,
		tmpkills = 4,
		rlm = 3,
		players = 4,
		srtd = 5
	},
	sound = {
		soundpath.."firstblood.mp3",
		soundpath.."doublekill.mp3",
		soundpath.."triplekill.mp3",
		soundpath.."ultrakill.mp3",
		soundpath.."monsterkill.mp3",
		soundpath.."killingspree.mp3",
		soundpath.."dominating.mp3",
		soundpath.."megakill.mp3",
		soundpath.."unstoppable.mp3",
		soundpath.."whickedsick.mp3",
		soundpath.."rampage.mp3",
		soundpath.."godlike.mp3",
		soundpath.."holyshit.mp3",
		soundpath.."ownage.mp3",
		soundpath.."headshot.mp3",
		soundpath.."headhunter.mp3",
		soundpath.."multikill.mp3",
		soundpath.."ludicrouskill.mp3",
		soundpath.."impressive.mp3",
		soundpath.."perfect.mp3",
	},
	fcolor = {
		["DEATHKNIGHT"] = {
			r = 0.77,
			g = 0.12,
			b = 0.23,
			h = "|cffc41f3b",
		},
		["DRUID"] = {
			r = 1.00,
			g = 0.49,
			b = 0.04,
			h ="|cffff7d0a",
		},
		["HUNTER"] = {
			r = 0.67,
			g = 0.83,
			b = 0.45,
			h ="|cffabd473",
		},
		["MAGE"] = {
			r = 0.41,
			g = 0.80,
			b = 0.94,
			h ="|cff69ccf0",
		},
		["MONK"] = {
			r = 0,
			g = 1,
			b = 0.59,
			h ="|cff00ff96",
		},
		["PALADIN"] = {
			r = 0.96,
			g = 0.55,
			b = 0.73,
			h ="|cfff58cba",
		},
		["PRIEST"] = {
			r = 1.00,
			g = 1.00,
			b = 1.00,
			h ="|cffffffff",
		},
		["ROGUE"] = {
			r = 1.00,
			g = 0.96,
			b = 0.41,
			h ="|cfffff569",
		},
		["SHAMAN"] = {
			r = 0.00,
			g= 0.44,
			b = 0.87,
			h = "|cff0070de",
		},
		["WARLOCK"] = {
			r = 0.58,
			g = 0.51,
			b = 0.79,
			h ="|cff9482c9",
		},
		["WARRIOR"] = {
			r = 0.78,
			g = 0.61,
			b = 0.43,
			h ="|cffc79c6e",
		},
		["orange"] = {
			r = 1,
			g = 0.4,
			b = 0,
			h = "|cffff6600",
		},
		["blzzyellow"] = {
			r = 1,
			g = 0.8196079,
			b = 0,
			h = "|cffffd700",
		},
		["white"] = {
			r = 1,
			g = 1,
			b = 1,
			h = "|cffffffff",
		},
		["orangered"] = {
			r = 1,
			g = 0.27,
			b = 0,
			h = "|cffff4500",
		},
		["darkgrey"] = "|cffa9a9a9",
		["lawngreen"] = "|cff7cfc00",
		["cyan"] = "|cff00ffff",
		["red"] = "|cffff0000",
	},
	ddDB = {
		fonts = {
			{fontpath.."AccidentalPresidency.ttf", "AccidentalPresidency"},
			{fontpath.."Aero Matics Display Regular.ttf", "Aero Matics Display Reg"},
			{fontpath.."Aero Matics Display Italic.ttf", "Aero Matics Display I"},
			{fontpath.."Aero Matics Display Bold.ttf", "Aero Matics Display Bold"},
			{fontpath.."Aero Matics Display Bold Italic.ttf", "Aero Matics Display Bold I"},
			{fontpath.."Alexandria.ttf", "Alexandria"},
			{fontpath.."AnonymousPro-Bold.ttf", "AnonymousPro Bold"},
			{fontpath.."Antibios.ttf", "Antibios"},
			{fontpath.."Antigon.ttf", "Antigon"},
			{"Fonts\\ARIALN.TTF", "ArialN"},
			{fontpath.."Bazooka.ttf", "Bazooka"},
			{fontpath.."Bienetresocial.ttf", "Bienetresocial"},
			{fontpath.."Binner.ttf", "Binner"},
			{fontpath.."BlasterInfinite.ttf", "BlasterInfinite"},
			{fontpath.."BlueHighway.ttf", "BlueHighway"},
			{fontpath.."Cabin.ttf", "Cabin"},
			{fontpath.."Cardiff.ttf", "Cardiff"},
			{fontpath.."Chen.ttf", "Chen"},
			{fontpath.."Collegiate.ttf", "Collegiate"},
			{fontpath.."Continuum.ttf", "Continuum"},
			{fontpath.."Copra.ttf", "Copra"},
			{fontpath.."Curse Casual JVE.ttf", "Curse Casual JVE"},
			{fontpath.."DORISPP.TTF", "DORISPP"},
			{fontpath.."Emotion Engine.ttf", "Emotion Engine"},
			{fontpath.."Enigma__2.TTF", "Enigma__2"},
			{fontpath.."EnterSansman.ttf", "EnterSansman"},
			{fontpath.."Equine.ttf", "Equine"},
			{fontpath.."Excite.ttf", "Excite"},
			{fontpath.."Fava-black.ttf", "Fava-black"},
			{"Fonts\\FRIZQT__.TTF", "FRIZQT"},
			{fontpath.."Fourche.ttf", "Fourche"},
			{fontpath.."FSEX300.ttf", "FSEX300"},
			{fontpath.."Geometry.ttf", "Geometry"},
			{fontpath.."Harlequin.ttf", "Harlequin"},
			{fontpath.."HFF Air Apparent.ttf", "HFF Air Apparent"},
			{fontpath.."Hiruko.ttf", "Hiruko"},
			{fontpath.."Invaders.ttf", "Invaders"},
			{fontpath.."Karat.ttf", "Karat"},
			{fontpath.."Kornik.ttf", "Kornik"},
			{fontpath.."launica.ttf", "launica"},
			{fontpath.."Laurentine.ttf", "Laurentine"},
			{fontpath.."Lexia.ttf", "Lexia"},
			{fontpath.."LiberationSans-Regular.ttf", "LiberationSans-Regular"},
			{fontpath.."LINEA___.TTF", "LINEA___F"},
			{fontpath.."linochsl.ttf", "linochsl"},
			{fontpath.."Medrano.ttf", "Medrano"},
			{fontpath.."Monoglyceride.ttf", "Monoglyceride"},
			{"Fonts\\MORPHEUS.ttf", "MORPHEUS"},
			{fontpath.."New Era Casual Bold Italic.ttf", "New Era Casual Bold Italic"},
			{fontpath.."New Era Casual Bold.ttf", "New Era Casual Bold"},
			{fontpath.."New Era Casual Italic.ttf", "New Era Casual Italic"},
			{fontpath.."New Era Casual Regular.ttf", "New Era Casual Regular"},
			{fontpath.."Norton.ttf", "Norton"},
			{fontpath.."Opal.ttf", "Opal"},
			{fontpath.."Orgreave.ttf", "Orgreave"},
			{fontpath.."Overseer.ttf", "Overseer"},
			{fontpath.."Phosphorus.ttf", "Phosphorus"},
			{fontpath.."RaggMopp.ttf", "RaggMopp"},
			{fontpath.."RiotSquad.ttf", "RiotSquad"},
			{fontpath.."Rocko.ttf", "Rocko"},
			{fontpath.."Serpentine.ttf", "Serpentine"},
			{"Fonts\\skurri.ttf", "skurri"},
			{fontpath.."Slicker.ttf", "Slicker"},
			{fontpath.."SnappyService.ttf", "SnappyService"},
			{fontpath.."Splendid Plan 9 Italic.ttf", "Splendid Plan 9 Italic"},
			{fontpath.."Splendid Plan 9 Regular.ttf", "Splendid Plan 9 Regular"},
			{fontpath.."Square.ttf", "Square"},
			{fontpath.."Sunbury.ttf", "Sunbury"},
			{fontpath.."Tempest.ttf", "Tempest"},
			{fontpath.."TimKid.ttf", "TimKid"},
			{fontpath.."Tuffy.ttf", "Tuffy"},
			{fontpath.."Typist.ttf", "Typist"},
			{fontpath.."UpheavalPro.ttf", "UpheavalPro"},
			{fontpath.."UrsaSerif.ttf", "UrsaSerif"},
			{fontpath.."Vinque.ttf", "Vinque"},
			{fontpath.."Walkway.ttf", "Walkway"},
			{fontpath.."Waukegan.ttf", "Waukegan"},
			{fontpath.."X360.ttf", "X360"},
			{fontpath.."Xpressive.ttf", "Xpressive"},
		},
		bg = {
			{nil, "No background"},
			{"Interface\\Tooltips\\UI-Tooltip-Background", "Tooltip"},
			{"Interface\\TutorialFrame\\TutorialFrameBackground", "Tutorial"},
			{"Interface\\DialogFrame\\UI-DialogBox-Background-Dark", "DialogDark"},
			{"Interface\\DialogFrame\\UI-DialogBox-Gold-Background", "DialogGold"},
			{"Interface\\BUTTONS\\UI-Listbox-Highlight", "Listbox"},
			{"Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal", "Parchment"},
			{"Interface\\AchievementFrame\\UI-GuildAchievement-Parchment-Horizontal", "Parchment 2"},
			{"World\\wmo\\Outland\\DarkPortal\\STARSPORTAL", "Stars"},
			{"ENVIRONMENTS\\STARS\\netherstorm_nebula_BK", "Nebula"},
			{"DUNGEONS\\BUILDINGS\\OL_NIGHTELF_INN_RUINED\\TEX\\SILVERMYST_INN_FLOOR", "Wood 1"},
 			{"DUNGEONS\\BUILDINGS\\OL_NIGHTELF_INN_RUINED\\TEX\\SILVERMYST_INN_FLOOR2", "Wood 2"},
			{"DUNGEONS\\BUILDINGS\\OL_NIGHTELF_INN_RUINED\\TEX\\SILVERMYST_INN_WALL01", "Wood 3"},
 			{"Interface\\PaperDollInfoFrame\\UI-GearManager-Title-Background", "Wood 4"},
 			{"ENVIRONMENTS\\STARS\\IceCrown_CloudCover_NIGHT", "Clouds dark"},
 			{"ENVIRONMENTS\\STARS\\IceCrown_CloudCover", "Clouds light"},
 			{"ENVIRONMENTS\\STARS\\STRATHOLMESHOT02", "Clouds red"},
			{"Interface\\BUTTONS\\BLUEGRAD64", "Blue 1"},
 			{"TILESET\\EmeraldDream\\DreamForestCreep", "Blue 2"},
 			{"TILESET\\EmeraldDream\\DreamRock01", "Spirals"},
 			{"TILESET\\EmeraldDream\\DreamForestMoss", "Moss"},
			{"TILESET\\Outland\\OutlandBones", "Bones"},
			{"TILESET\\Outland\\OutlandSand01", "Sand"},
 			{"TILESET\\EmeraldDream\\DreamGrass04", "Flowers"},
			{"Interface\\FullScreenTextures\\LowHealth", "Blood"},
--~ 			{"Interface\\FrameGeneral\\UI-Background-Marble", "Marble"},
			{"Interface\\FullScreenTextures\\OutOfControl", "OutOfControl"},
			{"Interface\\FrameGeneral\\UI-Background-Rock", "Rock"},
			{"Interface\\TabardFrame\\TabardFrameBackground", "Tabard"},
			{"Interface\\Buttons\\WHITE8X8", "White"},
 		},
		border = {
			{"Interface\\Tooltips\\UI-Tooltip-Border", "Tooltip"},
			{"Interface\\DialogFrame\\UI-DialogBox-Border", "Dialog"},
			{"Interface\\DialogFrame\\UI-DialogBox-Gold-Border", "DialogGold"},
--~ 			{"Interface\\AchievementFrame\\UI-Achievement-WoodBorder", "Blizzard Achievement Wood"},
		},
		fntflag = {
			{"OUTLINE", "Outline"},
			{"THICKOUTLINE", "Thickoutline"},
			{"MONOCHROME", "Monochrome"},
		},
		chatchan = {
			{DEFAULT, "DEFAULT"},
			{SAY, "SAY"},
			{YELL, "YELL"},
			{PARTY, "PARTY"},
			{RAID, "RAID"},
			{GUILD, "GUILD"},
			{BATTLEGROUND, "BATTLEGROUND"},
		},
 		plclass = {
 			{L["All classes"], "ALL CLASSES"},
 			{L["Deathknight"], "DEATHKNIGHT"},
 			{L["Druid"], "DRUID"},
 			{L["Hunter"], "HUNTER"},
			{L["Mage"], "MAGE"},
			{L["Monk"], "MONK"},
			{L["Paladin"], "PALADIN"},
			{L["Priest"], "PRIEST"},
			{L["Rogue"], "ROGUE"},
			{L["Shaman"],"SHAMAN"},
 			{L["Warlock"],"WARLOCK"},
 			{L["Warrior"], "WARRIOR"},
 		},
		plcl = L["All classes"],			-- class, classes shown in list
		emotes = {
			{EMOTE2_CMD1, "AMAZE"},
			{EMOTE3_CMD1, "ANGRY"},
			{EMOTE4_CMD1, "APOLOGIZE"},
			{EMOTE5_CMD1, "APPLAUD"},
			{EMOTE148_CMD1, "BARK"},
			{EMOTE7_CMD2, "BECKON"},
			{EMOTE18_CMD2, "BELCH"},
			{EMOTE8_CMD1, "BEG"},
			{EMOTE9_CMD1, "BITE"},
			{EMOTE368_CMD1, "BLAME"},
			{EMOTE11_CMD2, "BLINK"},
			{EMOTE12_CMD1, "BLUSH"},
			{EMOTE108_CMD2, "BOGGLE"},
			{EMOTE13_CMD1, "BONK"},
			{EMOTE14_CMD1, "BORED"},
			{EMOTE17_CMD1, "BOW"},
			{EMOTE16_CMD1, "BRB"},
			{EMOTE20_CMD1, "CACKLE"},
			{EMOTE109_CMD1, "CALM"},
			{EMOTE80_CMD3, "CATTY"},
			{EMOTE446_CMD1, "CHARM"},
			{EMOTE21_CMD1, "CHEER"},
			{EMOTE22_CMD1, "CHICKEN"},
			{EMOTE23_CMD1, "CHUCKLE"},
			{EMOTE24_CMD2, "CLAP"},
			{EMOTE111_CMD1, "COMFORT"},
			{EMOTE25_CMD1, "CONFUSED"},
			{EMOTE26_CMD1, "CONGRATULATE"},
			{EMOTE30_CMD1, "CRACK"},
			{EMOTE448_CMD1, "CROSSARMS"},
			{EMOTE32_CMD1, "CRY"},
			{EMOTE112_CMD1, "CUDDLE"},
			{EMOTE33_CMD1, "CURIOUS"},
			{EMOTE35_CMD1, "DANCE"},
			{EMOTE373_CMD1, "DOUBT"},
			{EMOTE36_CMD1, "DRINK"},
			{EMOTE37_CMD1, "DROOL"},
			{EMOTE19_CMD3, "FAREWELL"},
			{EMOTE390_CMD1, "FACEPALM"},
			{EMOTE40_CMD1, "FART"},
			{EMOTE41_CMD1, "FIDGET"},
			{EMOTE42_CMD1, "FLEX"},
			{EMOTE165_CMD1, "FLIRT"},
			{EMOTE58_CMD2, "FOOD"},
			{EMOTE43_CMD1, "FROWN"},
			{EMOTE44_CMD3, "GASP"},
			{EMOTE45_CMD1, "GAZE"},
			{EMOTE46_CMD2, "GIGGLE"},
			{EMOTE47_CMD1, "GLARE"},
			{EMOTE48_CMD1, "GLOAT"},
			{EMOTE394_CMD1, "GLOWER"},
			{EMOTE392_CMD1, "GO"},
			{EMOTE393_CMD1, "GOING"},
			{EMOTE170_CMD1, "GOLFCLAP"},
			{EMOTE19_CMD2, "GOODBYE"},
			{EMOTE49_CMD2, "GREET"},
			{EMOTE50_CMD1, "GRIN"},
			{EMOTE51_CMD1, "GROAN"},
			{EMOTE52_CMD1, "GROVEL"},
			{EMOTE147_CMD1, "GROWL"},
			{EMOTE53_CMD1, "GUFFAW"},
			{EMOTE54_CMD1, "HAIL"},
			{EMOTE55_CMD1, "HAPPY"},
			{EMOTE395_CMD1, "HEADACHE"},
			{EMOTE396_CMD1, "HICCUP"},
			{EMOTE380_CMD1, "HIGHFIVE"},
			{EMOTE398_CMD1, "HISS"},
			{EMOTE399_CMD1, "HOLDHAND"},
			{EMOTE83_CMD3, "HOLLER"},
			{EMOTE57_CMD1, "HUG"},
			{EMOTE401_CMD1, "HURRY"},
			{EMOTE157_CMD1, "INCOMING"},
			{EMOTE114_CMD3, "INSULT"},
			{EMOTE115_CMD1, "INTRODUCE"},
			{EMOTE403_CMD1, "JEALOUS"},
			{EMOTE116_CMD2, "JK"},
			{EMOTE59_CMD1, "KISS"},
			{EMOTE60_CMD1, "KNEEL"},
			{EMOTE61_CMD1, "LAUGH"},
			{EMOTE117_CMD1, "LICK"},
			{EMOTE118_CMD1, "LISTEN"},
			{EMOTE449_CMD1, "LOOK"},
			{EMOTE119_CMD1, "LOST"},
			{EMOTE152_CMD1, "LOVE"},
			{EMOTE404_CMD1, "LUCK"},
			{EMOTE63_CMD1, "MASSAGE"},
			{EMOTE406_CMD1, "MERCY"},
			{EMOTE64_CMD1, "MOAN"},
			{EMOTE120_CMD1, "MOCK"},
			{EMOTE153_CMD1, "MOO"},
			{EMOTE65_CMD2, "MOON"},
			{EMOTE66_CMD1, "MOURN"},
			{EMOTE407_CMD1, "MUTTER"},
			{EMOTE408_CMD1, "NERVOUS"},
			{EMOTE67_CMD1, "NO"},
			{EMOTE68_CMD1, "NOD"},
			{EMOTE69_CMD1, "NOSEPICK"},
			{EMOTE409_CMD1, "OFFER"},
			{EMOTE450_CMD1, "OBJECT"},
			{EMOTE162_CMD1, "OOM"},
			{EMOTE158_CMD1, "OPENFIRE"},
			{EMOTE70_CMD1, "PANIC"},
			{EMOTE169_CMD1, "PAT"},
			{EMOTE130_CMD2, "PEST"},
			{EMOTE410_CMD1, "PET"},
			{EMOTE411_CMD1, "PINCH"},
			{EMOTE149_CMD1, "PITY"},
			{EMOTE72_CMD1, "PLEAD"},
			{EMOTE73_CMD1, "POINT"},
			{EMOTE74_CMD1, "POKE"},
			{EMOTE121_CMD1, "PONDER"},
			{EMOTE122_CMD1, "POUNCE"},
			{EMOTE417_CMD1, "POUT"},
			{EMOTE123_CMD1, "PRAISE"},
			{EMOTE75_CMD1, "PRAY"},
			{EMOTE413_CMD2, "PROUD"},
			{EMOTE414_CMD1, "PROMISE"},
			{EMOTE415_CMD1, "PULSE"},
			{EMOTE416_CMD1, "PUNCH"},
			{EMOTE124_CMD1, "PURR"},
			{EMOTE126_CMD1, "RAISE"},
			{EMOTE76_CMD1, "RAWR"},
			{EMOTE127_CMD1, "READY"},
			{EMOTE418_CMD1, "REGRET"},
			{EMOTE306_CMD1, "RETREAT"},
			{EMOTE420_CMD1, "REVENGE"},
			{EMOTE77_CMD1, "ROFL"},
			{EMOTE76_CMD1, "ROAR"},
			{EMOTE78_CMD1, "RUDE"},
			{EMOTE422_CMD1, "RUFFLE"},
			{EMOTE423_CMD1, "SAD"},
			{EMOTE79_CMD1, "SALUTE"},
			{EMOTE150_CMD1, "SCARED"},
			{EMOTE424_CMD1, "SCOFF"},
			{EMOTE425_CMD1, "SCOLD"},
			{EMOTE426_CMD1, "SCOWL"},
			{EMOTE427_CMD1, "SEARCH"},
			{EMOTE81_CMD1, "SEXY"},
			{EMOTE82_CMD1, "SHAKE"},
			{EMOTE428_CMD1, "SHAKEFIST"},
			{EMOTE429_CMD1, "SHIFTY"},
			{EMOTE128_CMD1, "SHIMMY"},
			{EMOTE129_CMD1, "SHIVER"},
			{EMOTE130_CMD1, "SHOO"},
			{EMOTE84_CMD1, "SHRUG"},
			{EMOTE430_CMD1, "SHUDDER"},
			{EMOTE85_CMD1, "SHY"},
			{EMOTE86_CMD1, "SIGH"},
			{EMOTE431_CMD1, "SIGNAL"},
			{EMOTE432_CMD1, "SILENCE"},
			{EMOTE433_CMD1, "SING"},
			{EMOTE131_CMD1, "SLAP"},
			{EMOTE88_CMD1, "SLEEP"},
			{EMOTE145_CMD1, "SMILE"},
			{EMOTE132_CMD1, "SMIRK"},
			{EMOTE445_CMD1, "SNAP"},
			{EMOTE89_CMD1, "SNARL"},
			{EMOTE435_CMD1, "SNEAK"},
			{EMOTE436_CMD1, "SNEEZE"},
			{EMOTE141_CMD1, "SNICKER"},
			{EMOTE133_CMD1, "SNIFF"},
			{EMOTE437_CMD1, "SNORT"},
			{EMOTE134_CMD1, "SNUB"},
			{EMOTE135_CMD1, "SOOTHE"},
			{EMOTE90_CMD1, "SPIT"},
			{EMOTE438_CMD1, "SQUEAL"},
			{EMOTE91_CMD1, "STARE"},
			{EMOTE136_CMD1, "STINK"},
			{EMOTE92_CMD1, "SURPRISED"},
			{EMOTE93_CMD1, "SURRENDER"},
			{EMOTE440_CMD1, "SUSPICIOUS"},
			{EMOTE451_CMD1, "SWEAT"},
			{EMOTE94_CMD1, "TALK"},
			{EMOTE97_CMD1, "TAP"},
			{EMOTE137_CMD1, "TAUNT"},
			{EMOTE138_CMD1, "TEASE"},
			{EMOTE441_CMD1, "THINK"},
			{EMOTE139_CMD1, "THIRSTY"},
			{EMOTE142_CMD1, "TICKLE"},
			{EMOTE100_CMD1, "TIRED"},
			{EMOTE442_CMD1, "TRUCE"},
			{EMOTE443_CMD1, "TWIDDLE"},
			{EMOTE140_CMD1, "VETO"},
			{EMOTE101_CMD1, "VICTORY"},
			{EMOTE144_CMD1, "VIOLIN"},
			{EMOTE164_CMD1, "WAIT"},
			{EMOTE444_CMD1, "WARN"},
			{EMOTE102_CMD1, "WAVE"},
			{EMOTE103_CMD1, "WELCOME"},
			{EMOTE104_CMD1, "WHINE"},
			{EMOTE168_CMD1, "WINK"},
			{EMOTE106_CMD1, "WORK"},
			{EMOTE107_CMD1, "YAWN"},
 		},
	},
	calls = {
		api = {										-- localize lua API calls
			["createframe"] = CreateFrame,
		},
		globstr = {									-- localize global strings
			["keybut1"] = KEY_BUTTON1,
			["keybut2"] = KEY_BUTTON2,
			["shftkeytxt"] = SHIFT_KEY_TEXT,
			["altkeytxt"] = ALT_KEY,
			["close"] = CLOSE,
			["mmenu"] = MAIN_MENU,
			["default"] = DEFAULT,
		},
	},
	tbl = {									-- current tables to show pages from
		rlm = {
			["nme"] = {},
			["class"] = {},
			["kills"] = {},
			["tmpkills"] = {},
		},
		class = {
			["nme"] = {},
			["class"] = {},
			["kills"] = {},
			["tmpkills"] = {},
		},
		nme = {
			["nme"] = {},
			["class"] = {},
			["kills"] = {},
			["tmpkills"] = {},
		},
		players = {
			["nme"] = {},
			["class"] = {},
			["kills"] = {},
			["tmpkills"] = {},
		},
		srtd = {							-- sorted tables
			["nme"] = {},
			["class"] = {},
			["kills"] = {},
			["tmpkills"] = {},
		},
		ctbl = {							-- idstring of currently used tables
			"nme",
			"class",
			"rlm",							-- realm
			"players",
			"srtd",							-- sorted by kills
		},
		id = "nme",							-- tableid of currently used tables
	},
	kills = {
		kblows = 0,   						-- number off killing blows since login
		totkblows = 0,						-- total killing blows
		killsndnr = 0,
		tmpkilltable = {},					-- track kills made in current session
	},
	evar = {
		playername = "",
		destname = "",
		nmerealm = "",
		destclass = "",
		playerclass = "",
	},
	misc = {
		page = 1,							-- current page viewed
		lastmouseover = "",
		list = "kills",						-- sort by kills or by tmpkills
		realmname = GetRealmName(),			-- players realm
		currealm = L["All realms"],			-- realm currently shown
		realms = {},
		nmeurl = "",
	},
}

--------------------------------------------------------------------------------------------
--------------------------[[  PKBlow default settings  ]]-----------------------------------
--------------------------------------------------------------------------------------------

function PKBlow:LoadDefault()
	-- default values
	if not pkbDB then
		pkbDB = {
			kstreak = 0,
			optDB = {
				showlauncher = 1,							-- toggle show/hide minimapicon
				showchatmsg = 1,							-- toggle killing blow announce in chat
				showgamett = 1,								-- toggle gametooltip
				playsounds = 1,								-- toggle killing blow sounds
				doemote = 1,									-- toggle using emotes
				custemote = 0,								-- toggle use custom emotes
				custchat = 0,									-- toggle use custom chatmessage
				showpkbtt = 1, 								-- toggle PKBlowtooltips
				scrshot = 0,									-- toggle take screenshot
				kbannounce = 0, 								-- toggle killing blow announce frame
				kstreakreset = 0,								-- toggle reset killstreaks after leaving battleground or login off
			},
			ldbDB = {
				minimapicon ={
					minimapPos = 200,
					radius = 80,
					hide = false,								-- toggle show/hide minimapbutton
				},
			},
			settingsDB = {
				lang = "enGB",
				emotestokensDB = {
					[1] = strupper(strsub(EMOTE57_CMD1, 2)),
				},
				fontsDB = {
					Kb = "Fonts\\FRIZQT__.TTF",
					GUI = "Fonts\\FRIZQT__.TTF",
				},
				fntflDB = {
					Kb = {},
					GUI = {},
				},
				chatDB = {
					[1] = locDB.ddDB.chatchan[1][2],
				},
				custchat =  "",
				useremotes = {
					[1] = "No emotes",
				},
				guiDB = {
					mbg	= locDB.ddDB.bg[4][1],				-- background for mainframe
					cbg = locDB.ddDB.bg[4][1],				-- background for childframes
					border = locDB.ddDB.border[1][1],		-- borders for gui
					edgesize = 16,									-- edgesize of borders
					kbmsgfr = {
						xpos = 0,
						ypos = 0,
					},
					coords = {
					},
				},
				npcfilterDB = {
				},
			},
		}
	end
	if pkbDB.guiDB then									-- puts values of the old guiDB table of previous versions in the new format
		pkbDB.settingsDB.guiDB = pkbDB.guiDB
		pkbDB.guiDB = nil
	end
	if not pkbDB.kstreak then pkbDB.kstreak = 0 end
	if not pkbDB.optDB then pkbDB.optDB = {} end
	if not pkbDB.optDB.showlauncher then pkbDB.optDB.showlauncher = 1 end
	if not pkbDB.optDB.showchatmsg then pkbDB.optDB.showchatmsg = 1 end
	if not pkbDB.optDB.showgamett then pkbDB.optDB.showgamett = 1 end
	if not pkbDB.optDB.playsounds then pkbDB.optDB.playsounds = 1 end
	if not pkbDB.optDB.doemote then pkbDB.optDB.doemote = 1 end
	if not pkbDB.optDB.showpkbtt then pkbDB.optDB.showpkbtt = 1 end
	if not pkbDB.optDB.scrshot then pkbDB.optDB.scrshot = 0 end
	if not pkbDB.optDB.kbannounce then pkbDB.optDB.kbannounce = 0 end
	if not pkbDB.optDB.custchat then pkbDB.optDB.custchat = 0 end
	if not pkbDB.optDB.kstreakreset then pkbDB.optDB.kstreakreset = 0 end
	if not pkbDB.ldbDB then pkbDB.ldbDB = {} end
	if not pkbDB.ldbDB.minimapicon then pkbDB.ldbDB.minimapicon = {} end
	if not pkbDB.ldbDB.minimapicon.minimapPos then pkbDB.ldbDB.minimapicon.minimapPos = 200 end
	if not pkbDB.ldbDB.minimapicon.radius then pkbDB.ldbDB.minimapicon.radius = 80 end
	if not pkbDB.ldbDB.minimapicon.hide then pkbDB.ldbDB.minimapicon.hide = false end
	if not pkbDB.settingsDB then pkbDB.settingsDB = {} end
	if not pkbDB.settingsDB.lang then pkbDB.settingsDB.lang = {} end
	if #pkbDB.settingsDB.lang == 0 then tinsert(pkbDB.settingsDB.lang, "enGB") end
	if not pkbDB.settingsDB.emotestokensDB then pkbDB.settingsDB.emotestokensDB = {} end
	if pkbDB.optDB.doemote == 1 and not pkbDB.settingsDB.emotestokensDB[1] then tinsert(pkbDB.settingsDB.emotestokensDB, "HUG") end
	if not pkbDB.custchat then pkbDB.custchat = "" end
	if not pkbDB.settingsDB.guiDB then pkbDB.settingsDB.guiDB = {} end
	if not pkbDB.settingsDB.guiDB.mbg then pkbDB.settingsDB.guiDB.mbg = locDB.ddDB.bg[4][1] end
	if not pkbDB.settingsDB.guiDB.cbg then pkbDB.settingsDB.guiDB.cbg = locDB.ddDB.bg[4][1] end
	if not pkbDB.settingsDB.guiDB.border then pkbDB.settingsDB.guiDB.border = locDB.ddDB.border[1][1] end
	if not pkbDB.settingsDB.guiDB.edgesize then pkbDB.settingsDB.guiDB.edgesize = 16 end
	if not pkbDB.settingsDB.guiDB.kbmsgfr then pkbDB.settingsDB.guiDB.kbmsgfr = {} end
	if not pkbDB.settingsDB.guiDB.kbmsgfr.xpos then pkbDB.settingsDB.guiDB.kbmsgfr.xpos = 0 end
	if not pkbDB.settingsDB.guiDB.kbmsgfr.ypos then pkbDB.settingsDB.guiDB.kbmsgfr.ypos = 0 end
	if not pkbDB.settingsDB.guiDB.coords then pkbDB.settingsDB.guiDB.coords = {} end
--~ 	if not pkbDB.settingsDB.guiDB.coords.xpos then pkbDB.settingsDB.guiDB.coords.xpos = 0 end
--~ 	if not pkbDB.settingsDB.guiDB.coords.ypos then pkbDB.settingsDB.guiDB.coords.ypos = 0 end
	if not pkbDB.settingsDB.fontsDB then pkbDB.settingsDB.fontsDB = {} end
	if not pkbDB.settingsDB.fontsDB.GUI then pkbDB.settingsDB.fontsDB.GUI = "Fonts\\FRIZQT__.TTF" end
	if not pkbDB.settingsDB.fontsDB.Kb then pkbDB.settingsDB.fontsDB.Kb = "Fonts\\FRIZQT__.TTF" end
	if not pkbDB.settingsDB.fntflDB then pkbDB.settingsDB.fntflDB = {} end
	if not pkbDB.settingsDB.fntflDB.GUI then pkbDB.settingsDB.fntflDB.GUI = {} end
	for i = 1, 3 do
		if not pkbDB.settingsDB.fntflDB.GUI[i] or pkbDB.settingsDB.fntflDB.GUI[i] == 0 then
			pkbDB.settingsDB.fntflDB.GUI[i] = false
		elseif pkbDB.settingsDB.fntflDB.GUI[i] == 1 then
			pkbDB.settingsDB.fntflDB.GUI[i] = locDB.ddDB.fntflag[i][1]
		end
	end
	if not pkbDB.settingsDB.fntflDB.Kb then pkbDB.settingsDB.fntflDB.Kb = {} end
	for i = 1, 3 do
		if not pkbDB.settingsDB.fntflDB.Kb[i] or pkbDB.settingsDB.fntflDB.Kb[i] == 0 then
			pkbDB.settingsDB.fntflDB.Kb[i] = false
		elseif pkbDB.settingsDB.fntflDB.Kb[i] == 1 then
			pkbDB.settingsDB.fntflDB.Kb[i] = locDB.ddDB.fntflag[i][1]
		end
	end
	if not pkbDB.settingsDB.chatDB then pkbDB.settingsDB.chatDB = {} end
	if #pkbDB.settingsDB.chatDB == 0 then tinsert(pkbDB.settingsDB.chatDB, locDB.ddDB.chatchan[1][2]) end
	if not pkbDB.settingsDB.useremotes then pkbDB.settingsDB.useremotes = {} end
	if #pkbDB.settingsDB.useremotes == 0 then tinsert(pkbDB.settingsDB.useremotes, "No emotes") end
	if not pkbDB.settingsDB.custemotes then pkbDB.settingsDB.custemotes = {} end
	if not pkbDB.npcfilterDB then pkbDB.npcfilterDB = {} end
 	if not PKBlowDB then PKBlowDB = {} end
	if locDB.ddDB.plcl == "" then locDB.ddDB.plcl = locDB.ddDB.plclass[1][2] end
	if pkblocale == "ruRU" then
		locDB.ddDB.fonts = {
			{fontpath.."Aero Matics Display Regular.ttf", "Aero Matics Display Reg"},
			{fontpath.."Aero Matics Display Italic.ttf", "Aero Matics Display I"},
			{fontpath.."Aero Matics Display Bold.ttf", "Aero Matics Display Bold"},
			{fontpath.."Aero Matics Display Bold Italic.ttf", "Aero Matics Display Bold I"},
			{fontpath.."AnonymousPro-Bold.ttf", "AnonymousPro Bold"},
			{"Fonts\\ARIALN.TTF", "ArialN"},
			{fontpath.."FSEX300.ttf", "FSEX300"},
			{"Fonts\\FRIZQT__.TTF", "FRIZQT"},
			{fontpath.."Kornik.ttf", "Kornik"},
			{fontpath.."LiberationSans-Regular.ttf", "LiberationSans-Regular"},
			{"Fonts\\MORPHEUS.ttf", "MORPHEUS"},
			{"Fonts\\skurri.ttf", "skurri"},
			{fontpath.."UpheavalPro.ttf", "UpheavalPro"},
			{fontpath.."X360.ttf", "X360"},
		}
	elseif pkblocale == "koKR" or pkblocale == "zhCN" or pkblocale == "zhTW" then
		locDB.ddDB.fonts = {
			{"Fonts\\ARIALN.TTF", "ArialN"},
			{fontpath.."FSEX300.ttf", "FSEX300"},
			{"Fonts\\FRIZQT__.TTF", "FRIZQT"},
			{fontpath.."Kornik.ttf", "Kornik"},
			{fontpath.."launica.ttf", "launica"},
			{"Fonts\\MORPHEUS.ttf", "MORPHEUS"},
			{"Fonts\\skurri.ttf", "skurri"},
		}
	end

end

if not pkbDB then
	PKBlow:LoadDefault()
end

-------------------------------------------------------------------------------------------------------------
--------------------------[[  PKBlow functions  ]]-----------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

function PKBlow:ClassColor(myclass)

	local myclass = myclass
	local r, g, b, h = 0, 0, 0, 0                 -- red, green, blue, hex
	for index, value in ipairs(locDB.ddDB.plclass) do
		if myclass == locDB.ddDB.plclass[index][2] then
			r, g, b, h = locDB.fcolor[locDB.ddDB.plclass[index][2]].r, locDB.fcolor[locDB.ddDB.plclass[index][2]].g, locDB.fcolor[locDB.ddDB.plclass[index][2]].b, locDB.fcolor[locDB.ddDB.plclass[index][2]].h
		end
	end
	return r, g, b, h

end

function PKBlow:SetPopupDialogs()

	StaticPopupDialogs["PKBWIPE_BUTTON"] = {
		text = "Do you really want to wipe tables?",
		button1 = YES,
		button2 = NO,
		OnAccept = function()
			PKBlow:ResetTables()
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["PKBFILTER_BUTTON"] = {
		text = "Enter npc's name to add it to the filter",
		button1 = ADD.." npc",
		button2 = CANCEL,
		OnShow = function (self, data)
			self.editBox:SetText("")
		end,
		OnAccept = function (self, data, data2)
			local npcname = self.editBox:GetText()
			PKBlow:DeletePlayer(npcname)
		end,
		hasEditBox = true,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["PKBEMOTE_BUTTON"] = {
		text = "Add a custom emote",
		button1 = ADD.." emote",
		button2 = CANCEL,
		hasEditBox = true,
		editBoxWidth = 400,
		OnShow = function (self, data)
			self.editBox:SetText("")
			self:SetFrameStrata("TOOLTIP")
--			self:SetBackdropColor(0, 0, 0, 1)
			self:SetBackdrop({
				bgFile = locDB.ddDB.bg[7][1],
				edgeFile = locDB.ddDB.border[1][1],
				tile = false,
				tileSize = 16,
				edgeSize = 16,
				insets = {
					left = 3,
					right = 4,
					top = 4,
					bottom = 3
				}
			})
		end,
		OnAccept = function (self, data, data2)
			local emote = self.editBox:GetText()
			PKBlow:AddCustomEmote(emote)
			self:SetBackdrop(nil)
		end,
		hasEditBox = true,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["PKBDELETEEMOTE_BUTTON"] = {
		text = "Delete a custom emote",
		button1 = DELETE.." emote",
		button2 = CANCEL,
		hasEditBox = true,
		editBoxWidth = 400,
		OnShow = function (self, data)
			self.editBox:SetText("")
		end,
		OnAccept = function (self, data, data2)
			local emote = self.editBox:GetText()
			PKBlow:RemoveCustomEmote(emote)
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["PKBCOPYNME"] = {
		text = "Ctrl-c to copy URL, Ctrl-v to paste",
		button1 = "Exit",
		hasEditBox = true,
		editBoxWidth = 400,
		OnShow = function (self, data)
			self.editBox:SetText(locDB.misc.nmeurl)
			self.editBox:HighlightText()
			self.editBox:SetFocus()
		end,
		OnAccept = function()
			if locDB.bool.splayer == true or locDB.bool.getrealm == true then
				PKBlow_Search:SetFocus()
			end
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

	StaticPopupDialogs["PKBCUSTCHATMSG_BUTTON"] = {
		text = "Create a custom killing blow announce chat message.",
		button1 = "OK",
		button2 = CANCEL,
		hasEditBox = true,
		editBoxWidth = 600,
		OnShow = function (self, data)
			self.editBox:SetText(pkbDB.custchat)
			self:SetFrameStrata("TOOLTIP")
			self:SetBackdrop({
				bgFile = locDB.ddDB.bg[7][1],
				edgeFile = locDB.ddDB.border[1][1],
				tile = false,
				tileSize = 16,
				edgeSize = 16,
				insets = {
					left = 3,
					right = 4,
					top = 4,
					bottom = 3
				}
			})
		end,
		OnAccept = function (self, data, data2)
			local chatformat = self.editBox:GetText()
			if chatformat == "" then
				pkbDB.custchat = ""
				chatformat = locDB.fcolor.orangered.h.."<PKBlow>|r"..locDB.fcolor.blzzyellow.h.." No custom chat message found, use of custom chat message dissabled|r"
				DEFAULT_CHAT_FRAME:AddMessage(chatformat)
				pkbDB.optDB.custchat = 0
				_G["PKBlow_custchatCheckButton"]:SetChecked(false)
			else
				pkbDB.custchat = chatformat
			end
			self:SetBackdrop(nil)
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}

end

function PKBlow:SetDefault()

	pkbDB = nil
	PKBlow:LoadDefault()
	ReloadUI()

end

function PKBlow:SetCurrentTables(mytable, mytmpkilltable)

	local mytable, mytmpkilltable = mytable, mytmpkilltable
	local tableid = locDB.tbl.id
	wipe(locDB.tbl[tableid].nme)
	wipe(locDB.tbl[tableid].kills)
	wipe(locDB.tbl[tableid].tmpkills)
	wipe(locDB.tbl[tableid].class)
	for index, value in ipairs(mytable) do
		tinsert(locDB.tbl[tableid].nme, mytable[index][locDB.const.nme])
		tinsert(locDB.tbl[tableid].kills, mytable[index][locDB.const.kills])
		tinsert(locDB.tbl[tableid].tmpkills, mytmpkilltable[index])
		tinsert(locDB.tbl[tableid].class, mytable[index][locDB.const.class])
	end

end

function PKBlow:GetTableID()

	local tableid = locDB.tbl.id
	if locDB.bool.realmset == true and locDB.bool.class == true then
		tableid = locDB.tbl.ctbl[locDB.const.class]
	elseif locDB.bool.realmset == true and locDB.bool.class == false then
		tableid = locDB.tbl.ctbl[locDB.const.rlm]
	elseif locDB.bool.realmset == false and locDB.bool.class == true then
		tableid = locDB.tbl.ctbl[locDB.const.class]
	else
		local text = PKBlow_Search:GetText()
		if text and text ~= locDB.fcolor.darkgrey..L["Search"].."|r" then
			tableid = locDB.tbl.ctbl[locDB.const.rlm]
		else
			tableid = locDB.tbl.ctbl[locDB.const.nme]
		end
	end
	locDB.tbl.id = tableid
	return tableid

end

function PKBlow:KillSortHandler(list)

	local tableid = locDB.tbl.id
	local nmeindex = 0
	local pagenr = 1
	local list = list
	local kills = "kills"
	local tmpkills = "tmpkills"
	local text = PKBlow_Search:GetText()
	locDB.misc.list = list
	if (list == kills and locDB.bool.ksorted == false) or (list == tmpkills and locDB.bool.tksorted == false and locDB.kills.kblows ~= 0) then
 		if locDB.bool.realmset == true or (locDB.bool.getrealm == true and text ~= "") then
 			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.rlm]
 			tableid = locDB.tbl.id
		else
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.nme]
			tableid = locDB.tbl.id
		end
		if locDB.bool.class == true then
			PKBlow:ClassSelect(locDB.ddDB.plcl)
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.class]
			tableid = locDB.tbl.id
		end
		if locDB.bool.splayer == true then
			PKBlow:SetPlayer()
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.players]
			tableid = locDB.tbl.id
		end
		local mytable = locDB.tbl[tableid].kills
		local start = 1
		local count = #mytable
		PKBlow:SortKills(mytable, start, count, list)
		if list == kills then
			locDB.bool.ksorted = true
			locDB.bool.tksorted = false
		else
			locDB.bool.tksorted = true
			locDB.bool.ksorted = false
		end
	elseif (list == kills and locDB.bool.ksorted == true) or (list == tmpkills and locDB.bool.tksorted == true and locDB.kills.kblows ~= 0) then
		if locDB.bool.realmset == true then
  			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.rlm]
 			tableid = locDB.tbl.id
		elseif locDB.bool.getrealm == true and text ~= "" then
			PKBlow:SetRealm()
		else
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.nme]
			tableid = locDB.tbl.id
			PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
		end
		if locDB.bool.class == true then
			PKBlow:ClassSelect(locDB.ddDB.plcl)
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.class]
			tableid = locDB.tbl.id
		end
		if locDB.bool.splayer == true then
			PKBlow:SetPlayer()
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.players]
			tableid = locDB.tbl.id
		end
		tableid = locDB.tbl.id
		locDB.bool.ksorted = false
		locDB.bool.tksorted = false
	end
	PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)

end

function PKBlow:SortKills(mytable, start, count, list)          -- quicksort

	local mytable = mytable
	local start, count = start, count
	local list = list
	local tableid = locDB.tbl.id
	local kills = "kills"
	locDB.tbl.srtd.nme = locDB.tbl[tableid].nme
	locDB.tbl.srtd.kills = locDB.tbl[tableid].kills
	locDB.tbl.srtd.tmpkills = locDB.tbl[tableid].tmpkills
	locDB.tbl.srtd.class = locDB.tbl[tableid].class
	locDB.tbl.id = locDB.tbl.ctbl[locDB.const.srtd]
	if count - start < 1 then
		return
	end
	local pivot = start
	if list == kills then
		for index = start + 1, count do
			if locDB.tbl[tableid][list][index] and locDB.tbl[tableid][list][index] > 1 and locDB.tbl[tableid][list][index] >= locDB.tbl[tableid][list][pivot] then
				local nmetmp = locDB.tbl[tableid].nme[pivot + 1]
				local killtmp = locDB.tbl[tableid].kills[pivot + 1]
				local tmpkilltmp = locDB.tbl[tableid].tmpkills[pivot + 1]
				local classtmp = locDB.tbl[tableid].class[pivot + 1]
				locDB.tbl[tableid].nme[pivot + 1] = locDB.tbl[tableid].nme[pivot]
				locDB.tbl[tableid].kills[pivot + 1] = locDB.tbl[tableid].kills[pivot]
				locDB.tbl[tableid].tmpkills[pivot + 1] = locDB.tbl[tableid].tmpkills[pivot]
				locDB.tbl[tableid].class[pivot + 1] = locDB.tbl[tableid].class[pivot]
				if index == pivot + 1 then
					locDB.tbl[tableid].nme[pivot] = nmetmp
					locDB.tbl[tableid].kills[pivot] = killtmp
					locDB.tbl[tableid].tmpkills[pivot] = tmpkilltmp
					locDB.tbl[tableid].class[pivot] = classtmp
				else
					locDB.tbl[tableid].nme[pivot] = locDB.tbl[tableid].nme[index]
					locDB.tbl[tableid].kills[pivot] = locDB.tbl[tableid].kills[index]
					locDB.tbl[tableid].tmpkills[pivot] = locDB.tbl[tableid].tmpkills[index]
					locDB.tbl[tableid].class[pivot] = locDB.tbl[tableid].class[index]
					locDB.tbl[tableid].nme[index] = nmetmp
					locDB.tbl[tableid].kills[index] = killtmp
					locDB.tbl[tableid].tmpkills[index] = tmpkilltmp
					locDB.tbl[tableid].class[index] = classtmp
				end
				pivot = pivot + 1
			end
		end
	else
		if locDB.kills.kblows ~= 0 then
			for index = start + 1, count do
				if locDB.tbl[tableid][list][index] and locDB.tbl[tableid][list][index] > 0 and locDB.tbl[tableid][list][index] >= locDB.tbl[tableid][list][pivot] then
					local nmetmp = locDB.tbl[tableid].nme[pivot + 1]
					local killtmp = locDB.tbl[tableid].kills[pivot + 1]
					local tmpkilltmp = locDB.tbl[tableid].tmpkills[pivot + 1]
					local classtmp = locDB.tbl[tableid].class[pivot + 1]
					locDB.tbl[tableid].nme[pivot + 1] = locDB.tbl[tableid].nme[pivot]
					locDB.tbl[tableid].kills[pivot + 1] = locDB.tbl[tableid].kills[pivot]
					locDB.tbl[tableid].tmpkills[pivot + 1] = locDB.tbl[tableid].tmpkills[pivot]
					locDB.tbl[tableid].class[pivot + 1] = locDB.tbl[tableid].class[pivot]
					if index == pivot + 1 then
						locDB.tbl[tableid].nme[pivot] = nmetmp
						locDB.tbl[tableid].kills[pivot] = killtmp
						locDB.tbl[tableid].tmpkills[pivot] = tmpkilltmp
						locDB.tbl[tableid].class[pivot] = classtmp
					else
						locDB.tbl[tableid].nme[pivot] = locDB.tbl[tableid].nme[index]
						locDB.tbl[tableid].kills[pivot] = locDB.tbl[tableid].kills[index]
						locDB.tbl[tableid].tmpkills[pivot] = locDB.tbl[tableid].tmpkills[index]
						locDB.tbl[tableid].class[pivot] = locDB.tbl[tableid].class[index]
						locDB.tbl[tableid].nme[index] = nmetmp
						locDB.tbl[tableid].kills[index] = killtmp
						locDB.tbl[tableid].tmpkills[index] = tmpkilltmp
						locDB.tbl[tableid].class[index] = classtmp
					end
					pivot = pivot + 1
				end
			end
		end
	end
	mytable = PKBlow:SortKills(mytable, start, pivot - 1, list)
	return PKBlow:SortKills(mytable, pivot + 1, count, list)

end

function PKBlow:CopyNme(frname, index)

	if frname then
		local frname = frname
		local pkbportal = GetCVar("realmList")
		local lang = strsub(pkblocale, 1, 2)
		local region = strlower(strsub(pkblocale, 3, 4))
		local pattern = strfind(frname, "%d")
		local index = index
		local tableid = locDB.tbl.id
		local msg = ""
		index = (locDB.const.MAXLINES * (locDB.misc.page - 1)) + index
		local nme = locDB.tbl[tableid].nme[index]
		if nme then
			pattern = strfind(nme, "%p")
			local realm = strsub(nme, pattern + 1)
			nme = strsub(nme, 1, pattern - 1)
			pkbportal = strsub(pkbportal, 1, 2)
			if lang == "zh" then
				if region == "cn" then
					msg = "http://www.battlenet.com."..region.."/wow/"..lang.."/character/"..realm.."/"..nme.."/advanced"
				else
					msg = "http://"..region..".battle.net/wow/"..lang.."/character/"..realm.."/"..nme.."/advanced"
				end
			else
				msg = "http://"..pkbportal..".battle.net/wow/"..lang.."/character/"..realm.."/"..nme.."/advanced"
			end
			locDB.misc.nmeurl = msg
			StaticPopup_Show("PKBCOPYNME")
		end
	end

end

function PKBlow:GetRealms()

	for index, value in ipairs(PKBlowDB) do
		local realm = ""
		local pattern = strfind(PKBlowDB[index][locDB.const.nme], "%p")
		if pattern == nil then
			realm = locDB.misc.realmname
		else
			realm = strsub(PKBlowDB[index][locDB.const.nme], pattern + 1)
		end
		tinsert(locDB.misc.realms, realm)
	end
    for index, value in ipairs(locDB.misc.realms) do          	-- remove duplicates
		local count = #locDB.misc.realms
		while count ~= index do
			if locDB.misc.realms[index] == locDB.misc.realms[count] then
				tremove(locDB.misc.realms, count)
			end
		count = count - 1
		end
	end

end

-- counts pvp killing blows
function PKBlow:Counter()

	locDB.kills.totkblows = locDB.kills.totkblows + 1
	locDB.kills.kblows = locDB.kills.kblows + 1

end

-- count total kills and kills since last reset (killcount resets when player leaves game)
function PKBlow:KillCount()

	local count = 0
	local tableid = locDB.tbl.id
	for index, value in ipairs(locDB.tbl[tableid].kills) do
		count = count + locDB.tbl[tableid].kills[index]
	end
	locDB.kills.totkblows = count
	count = 0
	for index, value in ipairs(locDB.tbl[tableid].tmpkills) do
		count = count + locDB.tbl[tableid].tmpkills[index]
	end
	locDB.kills.kblows = count

end

function PKBlow:LdbKillsMsg()

	local msg = " "
	if locDB.kills.totkblows == 1 then
		msg = "|r "..L["kill"]
	else
		msg = "|r "..L["kills"]
	end
	return msg

end

function PKBlow:TotalKillMsg()

	local totkillsmsg = L["Total KB's = "]..locDB.kills.totkblows
	local curkillsmsg = L["Current KB's = "]..locDB.kills.kblows
	PKBKillsFrame:Clear()
	PKBKillsFrame:AddMessage(totkillsmsg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	PKBKillsFrame:AddMessage(curkillsmsg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	PKBlauncher.text = locDB.fcolor.orangered.h..locDB.kills.totkblows.."|r "..L["kills"]

end

function PKBlow:AddCustomEmote(emote)

	local emote = emote
	if pkbDB.settingsDB.useremotes[1] == "No emotes" then
		tremove(pkbDB.settingsDB.useremotes, 1)
	end
	tinsert(pkbDB.settingsDB.useremotes, emote)

end

function PKBlow:RemoveCustomEmote(emote)

	local emote = emote
	local match = false
	for index, value in ipairs(pkbDB.settingsDB.useremotes) do
		if emote == pkbDB.settingsDB.useremotes[index] then
			tremove(pkbDB.settingsDB.useremotes, index)
			match = true
		end
	end
	if #pkbDB.settingsDB.useremotes == 0 then
		tinsert(pkbDB.settingsDB.useremotes, "No emotes")
	end
	if match == false then
		if emote == "" then
			print(locDB.fcolor.orangered.h.."PKBlow:|r "..CUSTOM.." "..strlower(EMOTE).." \" \""..L[" not found"])
		else
			print(locDB.fcolor.orangered.h.."PKBlow:|r "..CUSTOM.." "..strlower(EMOTE).." \""..emote.."\""..L[" not found"])
		end
	end

end

function PKBlow:SortTable()

	sort(locDB.ddDB.emotes, function(a,b) return a[1] < b[1] end)

end

function PKBlow:CustChatFormat(kills, default, playercolor, destcolor)

	local chatformat = pkbDB.custchat
	local kills = kills
	local curkills = 1
	local default = default
	local playercolor, destcolor = playercolor, destcolor
	if not playercolor then
		playercolor = ""
	end
	if not destcolor then
		destcolor = ""
	end
	for index, value in ipairs(PKBlowDB) do
		if locDB.evar.destname == PKBlowDB[index][locDB.const.nme] then
  			kills = PKBlowDB[index][locDB.const.kills]
			curkills = locDB.kills.tmpkilltable[index]
		end
	end
	local tokens = {
		{"\<myname\>", locDB.evar.playername, playercolor..locDB.evar.playername.."|r"},
		{"\<myserver\>", locDB.misc.realmname, playercolor..locDB.misc.realmname.."|r"},
		{"\<nmename\>", locDB.evar.destname, destcolor..locDB.evar.destname.."|r"},
		{"\<nmeserver\>", locDB.evar.nmerealm, destcolor..locDB.evar.nmerealm.."|r"},
		{"\<curkills\>", curkills},
		{"\<totkills\>", kills},
		{"\<killspree\>", pkbDB.kstreak},
	}
	for i, v in ipairs(tokens) do
		local match = strmatch(chatformat, tokens[i][1])
		if match then
			if default and i < 5 then
				chatformat = string.gsub(chatformat, tokens[i][1], tokens[i][3])
			else
				chatformat = string.gsub(chatformat, tokens[i][1], tokens[i][2])
			end
		end
	end
	return chatformat

end

function PKBlow:GetLocalizedClass(class)

	local class = class or locDB.ddDB.plcl
	for index, value in ipairs(locDB.ddDB.plclass) do
		if class == locDB.ddDB.plclass[index][2] then
			class = locDB.ddDB.plclass[index][1]
		end
	end
	return class

end

-- get the amount of pages ( 1 page has 25 entries), rest is amount of players on last page
function PKBlow:Pages(mytable)

	local mytable = mytable
	local count = #(mytable)
	local rest = 0
	local pages = floor(count / locDB.const.MAXLINES)
	local pagenr = locDB.misc.page
	if count == 0 then
		pagenr = 1
		pages = 1
		rest = 0
	elseif count <= locDB.const.MAXLINES then
		pagenr = 1
		pages = 1
		rest = count
	elseif count == locDB.const.MAXLINES * pages then
		rest = locDB.const.MAXLINES
	else
		rest = count - (locDB.const.MAXLINES * pages)
		if rest > 0 then
			pages = pages + 1
		end
	end
	return pagenr, pages, rest

end

-- for each player in killtable set tmpkilltable to 0
function PKBlow:ClearTempNmeKills()

	for index, value in ipairs(PKBlowDB) do
		local nme = PKBlowDB[index][locDB.const.nme]
		local pattern = strfind(nme, "%p")
		if pattern == nil then
			nme = nme.."-"..locDB.misc.realmname
			PKBlowDB[index][locDB.const.nme] = nme
		end
		locDB.kills.tmpkilltable[index] = 0
	end

end

function PKBlow:CleanNmeTable()

	for index, value in ipairs(PKBlowDB) do
		for i, v in ipairs(pkbDB.npcfilterDB) do
			local npcfilter = pkbDB.npcfilterDB[i]
			if strlower(npcfilter) == strlower(PKBlowDB[index][locDB.const.nme]) then
				tremove(PKBlowDB, index)
			end
		end
	end

end

function PKBlow:ClearFrames()

	local frame = {PKBNmeFrame, PKBTotalKilledFrame, PKBTempKilledFrame}
	for index, value in ipairs(frame) do
		frame[index]:Clear()
	end

end

function PKBlow:GetNmeIndex(mytable)

	local mytable = mytable
	local count = #(mytable)
	local nmeindex = 0
	local pagenr, _, _ = PKBlow:Pages(mytable)
	if count == 0 then
		nmeindex = 0
	else
		nmeindex = locDB.const.MAXLINES * (pagenr - 1)
	end
	return nmeindex

end

function PKBlow:KBHandler(destname, destguid, playername, destclass, playerclass)

	local destname, destguid, playername, destclass, playerclass = destname, destguid, playername, destclass, playerclass
	local _, dclass, _, _, _ = GetPlayerInfoByGUID(destguid)
	local pattern = strfind(destname, "%p")
	if pattern == nil then
		locDB.evar.destname = destname
		locDB.evar.nmerealm = locDB.misc.realmname
		destname = destname.."-"..locDB.evar.nmerealm
	else
		locDB.evar.destname = strsub(destname, 1, pattern - 1)
		locDB.evar.nmerealm = strsub(destname, pattern + 1)
	end
	locDB.evar.playername = playername
	if destclass ~= dclass and dclass ~= nil then
		destclass = dclass
	end
	locDB.kills.killsndnr = locDB.kills.killsndnr + 1
	pkbDB.kstreak = pkbDB.kstreak + 1
	if pkbDB.optDB.kbannounce == 1 then
		local msg = L["Killing blow"]
		PKBKbMessageFrame:AddMessage(msg, locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
	end
	if pkbDB.optDB.playsounds == 1 then
		local soundfile = PKBlow:SoundFileHandler(locDB.kills.killsndnr)
		PlaySoundFile(soundfile, "Master")
	end
	if pkbDB.optDB.doemote == 1 then
		local count = #pkbDB.settingsDB.emotestokensDB
		if count > 0 then
			local index = math.random(1, count)
			local emote = pkbDB.settingsDB.emotestokensDB[index]
			for index, value in ipairs (locDB.ddDB.emotes) do
				if emote == locDB.ddDB.emotes[index][2] then
					DoEmote(emote)
				end
			end
		end
	end
	if pkbDB.optDB.scrshot == 1 then
		Screenshot()
	end
--	UseItemByName("Gin-Ji Knife Set", destname)
	PKBlow:NmeKillCounter(destname, playername, destclass, playerclass)

end

function PKBlow:KillStreakHandler(event)

	local event = event
	if event == "PLAYER_DEAD" or (pkbDB.optDB.kstreakreset == 1 and (event == "PLAYER_ENTERING_BATTLEGROUND" or "PLAYER_ENTERING_WORLD")) then
		pkbDB.kstreak = 0
		locDB.kills.killsndnr = pkbDB.kstreak
	end

end

function PKBlow:SoundFileHandler(sndfilenr)

	local sndfilenr = sndfilenr
	local soundf = ""
	if sndfilenr <= 20 then
		for index, value in ipairs(locDB.sound) do
			if index == sndfilenr then
				soundf = locDB.sound[index]
			end
		end
	elseif sndfilenr > 20 then
		local index = math.random(17, 20)
		soundf = locDB.sound[index]
	end
	return soundf

end

-- show previous page
function PKBlow:PageBack(nmeindex, pagenr, mytable, mykilltable, mytmpkilltable, myclasstable)

	local nmeindex, pagenr = nmeindex, pagenr
	local mytable, mykilltable, mytmpkilltable, myclasstable = mytable, mykilltable, mytmpkilltable, myclasstable
	local _, pages, rest = PKBlow:Pages(mytable)
	local frame = {PKBNmeFrame, PKBTotalKilledFrame, PKBTempKilledFrame}
	PKBlow:ClearFrames()
	locDB.misc.page = pagenr
	for index, value in ipairs(mytable) do
		if index <= locDB.const.MAXLINES then
			nmeindex = nmeindex + 1
			local nrcolor = locDB.fcolor.white.h..(nmeindex)..". |r"
			local r, g, b, _ = PKBlow:ClassColor(myclasstable[nmeindex])
			local msg = mytable[nmeindex]
			local pattern = strfind(msg, "%p")
			if pattern == nil then
				msg = msg.."-"..locDB.misc.realmname
				nrcolor = locDB.fcolor.blzzyellow.h..(nmeindex)..". |r"
			else
				local plrealm = strsub(mytable[nmeindex], pattern + 1)
				if plrealm == locDB.misc.realmname then
					nrcolor = locDB.fcolor.blzzyellow.h..(nmeindex)..". |r"
				end
			end
			if nmeindex < 10 then
				frame[1]:AddMessage("    "..nrcolor..msg, r, g, b)
			else
				frame[1]:AddMessage("  "..nrcolor..msg, r, g, b)
			end
			frame[2]:AddMessage(mykilltable[nmeindex], 0.0, 1.0, 1.0)
			frame[3]:AddMessage(mytmpkilltable[nmeindex], 1.0, 0.0, 0.0)
		end
	end
	if pages == 1 and rest ~= 0 then
		local count = locDB.const.MAXLINES - rest
		while count ~= 0 do
			for index, value in ipairs(frame) do
				frame[index]:AddMessage(" ")
			end
			count = count - 1
		end
	end

end

-- show next 25 players
function PKBlow:NextPage(nmeindex, pagenr, mytable, mykilltable, mytmpkilltable, myclasstable)

	local nmeindex, pagenr = nmeindex, pagenr
	local mytable, mykilltable, mytmpkilltable, myclasstable = mytable, mykilltable, mytmpkilltable, myclasstable
	local _, pages, rest = PKBlow:Pages(mytable)
	local count = (locDB.const.MAXLINES - rest)
	local frame = {PKBNmeFrame, PKBTotalKilledFrame, PKBTempKilledFrame}
	PKBlow:ClearFrames()
	locDB.misc.page = pagenr
	if nmeindex == (pages * locDB.const.MAXLINES) + 1 then			-- make new page if we filled previous one
		pages = pages + 1
	end
	if pagenr == pages then
		while rest ~= 0 do
			local nrcolor = locDB.fcolor.white.h..(nmeindex + 1)..". |r"
			local r, g, b, _ = PKBlow:ClassColor(myclasstable[nmeindex + 1])
			local msg = mytable[nmeindex + 1]
			local pattern = strfind(msg, "%p")
			if pattern == nil then
				msg = msg.."-"..locDB.misc.realmname
				nrcolor = locDB.fcolor.blzzyellow.h..(nmeindex + 1)..". |r"
			else
				local plrealm = strsub(mytable[nmeindex + 1], pattern + 1)
				if plrealm == locDB.misc.realmname then
					nrcolor = locDB.fcolor.blzzyellow.h..(nmeindex + 1)..". |r"
				end
			end
			if (nmeindex + 1) < 10 then
				frame[1]:AddMessage("    "..nrcolor..msg, r, g, b)
			else
				frame[1]:AddMessage("  "..nrcolor..msg, r, g, b)
			end
			frame[2]:AddMessage(mykilltable[nmeindex + 1], 0.0, 1.0, 1.0)
			frame[3]:AddMessage(mytmpkilltable[nmeindex + 1], 1.0, 0.0, 0.0)
			nmeindex = nmeindex + 1
			rest = rest - 1
		end
		-- if last page doesn't contain 25 nmeplayers, fill empty spaces so players show up on top of the frame,
		-- workaround for SetInsertMode bug
		while count ~= 0 do
			for index, value in ipairs(frame) do
				frame[index]:AddMessage(" ")
			end
			count = count - 1
		end
	else
		for index, value in ipairs(mytable) do
			if index > nmeindex and index < (nmeindex + locDB.const.MAXLINES + 1) then
				local nrcolor = locDB.fcolor.white.h..(index)..". |r"
				local r, g, b, _ = PKBlow:ClassColor(myclasstable[index])
				local msg = mytable[index]
				local pattern = strfind(msg, "%p")
				if pattern == nil then
					msg = msg.."-"..locDB.misc.realmname
					nrcolor = locDB.fcolor.blzzyellow.h..(index)..". |r"
				else
					local plrealm = strsub(mytable[index], pattern + 1)
					if plrealm == locDB.misc.realmname then
						nrcolor = locDB.fcolor.blzzyellow.h..(index)..". |r"
					end
				end
				if index < 10 then
					frame[1]:AddMessage("    "..nrcolor..msg, r, g, b)
				else
					frame[1]:AddMessage("  "..nrcolor..msg, r, g, b)
				end
				frame[2]:AddMessage(mykilltable[index], 0.0, 1.0, 1.0)
				frame[3]:AddMessage(mytmpkilltable[index], 1.0, 0.0, 0.0)
			end
		end
	end
	local msg = pagenr.."/"..pages
	PKBPagesFrame:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	PKBlow:KillCount()
	PKBlow:TotalKillMsg()

end

function PKBlow:ClassSelect(class)

	local mytable = {}
	local mykilltable = {}
	local mytmpkilltable = {}
	local myclasstable = {}
	local class = class
	local globclass = strupper(class)
	local pagenr = 1
	local nmeindex = 0
	local text = PKBlow_Search:GetText()
	local tableid = locDB.tbl.id
	local realm = locDB.misc.currealm
	if #locDB.tbl.class.nme ~= 0 then
		wipe(locDB.tbl.class.nme)
		wipe(locDB.tbl.class.kills)
		wipe(locDB.tbl.class.tmpkills)
		wipe(locDB.tbl.class.class)
	end
	if locDB.bool.getrealm == true and text then
		tableid = locDB.tbl.ctbl[locDB.const.rlm]
	elseif locDB.bool.getrealm == true and text == "" then
		tableid = locDB.tbl.ctbl[locDB.const.nme]
	elseif locDB.bool.getrealm == false and locDB.bool.realmset == true then
		tableid = locDB.tbl.ctbl[locDB.const.rlm]
	else
		tableid = locDB.tbl.ctbl[locDB.const.nme]
	end
	locDB.tbl.id = tableid
	if class == locDB.ddDB.plclass[1][2] then
		for index, value in ipairs(locDB.tbl[tableid].class) do
			tinsert(locDB.tbl.class.nme, locDB.tbl[tableid].nme[index])
			tinsert(locDB.tbl.class.kills, locDB.tbl[tableid].kills[index])
			tinsert(locDB.tbl.class.tmpkills, locDB.tbl[tableid].tmpkills[index])
			tinsert(locDB.tbl.class.class, locDB.tbl[tableid].class[index])
		end
	else
		for index, value in ipairs(locDB.tbl[tableid].class) do
			if value == globclass then
				tinsert(locDB.tbl.class.nme, locDB.tbl[tableid].nme[index])
				tinsert(locDB.tbl.class.kills, locDB.tbl[tableid].kills[index])
				tinsert(locDB.tbl.class.tmpkills, locDB.tbl[tableid].tmpkills[index])
				tinsert(locDB.tbl.class.class, locDB.tbl[tableid].class[index])
			end
		end
	end
	tableid = locDB.tbl.ctbl[locDB.const.class]
	locDB.tbl.id = tableid
	local realm = locDB.misc.currealm
	if locDB.bool.getrealm == true and locDB.bool.realmset == false then
		if locDB.misc.currealm ~= L["All realms"] then
			realm = realm.."..."
		end
	end
	if locDB.bool.splayer == true then
		PKBlow:SetPlayer()
	end
	local class = PKBlow:GetLocalizedClass()
	local msg = realm.." - "..strlower(class)
	if class ~= locDB.ddDB.plclass[1][1] then
		locDB.bool.class = true
	end
	if locDB.bool.ksorted == true then
		locDB.bool.ksorted = false
		local list = "kills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	elseif locDB.bool.tksorted == true then
		locDB.bool.tksorted = false
		local list = "tmpkills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	end
	PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
	PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)

end

function PKBlow:SetRealm()

	local mytable = {}
	local mykilltable = {}
	local mytmpkilltable = {}
	local myclasstable = {}
	local realmtable = {}
	local nmeindex = 0
	local text = PKBlow_Search:GetText()
	local realm = locDB.misc.currealm
	local length = strlen(text)
	local pagenr = 1
	local tableid = locDB.tbl.ctbl[locDB.const.nme]
	locDB.tbl.id = tableid
	if locDB.bool.realmset == true then
		text = locDB.misc.currealm
	end
	if locDB.bool.splayer == true then
		text = realm
	end
	for index, value in ipairs(locDB.tbl[tableid].nme) do
		local pattern = strfind(locDB.tbl[tableid].nme[index], "%p")
		if pattern == nil then
			realm = locDB.misc.realmname
		else
			realm = strsub(locDB.tbl[tableid].nme[index], pattern + 1)
		end
		if locDB.bool.realmset == true then
			pattern = strsub(realm, 1)
		else
			pattern = strsub(realm, 1, length)
		end
		if strlower(text) == strlower(pattern) then
			tinsert(mytable,locDB.tbl[tableid].nme[index])
			tinsert(mykilltable, locDB.tbl[tableid].kills[index])
			tinsert(mytmpkilltable, locDB.tbl[tableid].tmpkills[index])
			tinsert(myclasstable, locDB.tbl[tableid].class[index])
			tinsert(realmtable, realm)
		end
	end
	locDB.tbl.rlm.nme = mytable
	locDB.tbl.rlm.kills = mykilltable
	locDB.tbl.rlm.tmpkills = mytmpkilltable
	locDB.tbl.rlm.class = myclasstable
	for index, value in ipairs(realmtable) do          	-- remove duplicates in realmtable
		local count = #realmtable
		while count ~= index do
			if realmtable[index] == realmtable[count] then
				tremove(realmtable, count)
			end
		count = count - 1
		end
	end
	local class = PKBlow:GetLocalizedClass()
	if length == 0 then
		local msg = L["All realms"].." - "..strlower(class)
		tableid = locDB.tbl.ctbl[locDB.const.nme]
		locDB.tbl.id = tableid
		locDB.misc.currealm = L["All realms"]
		PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	else
		if locDB.bool.splayer == false then
			if locDB.bool.getrealm == true and locDB.bool.realmset == false then
				realm = text
				locDB.misc.currealm = realm
				if locDB.misc.currealm ~= L["All realms"] then
					realm = text.."..."
				end
			end
		end
		local msg = realm.." - "..strlower(class)
		tableid = locDB.tbl.ctbl[locDB.const.rlm]
		locDB.tbl.id = tableid
		PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	end
	if #realmtable == 1  then
		locDB.misc.currealm = realmtable[1]
		local msg = locDB.fcolor.blzzyellow.h..locDB.misc.currealm.."|r"
		locDB.bool.realmset = true
		locDB.bool.getrealm = false
		if locDB.bool.splayer == false then
			PKBlow_Search:SetText(msg)
		end
		PKBlow_Search:ClearFocus()
		tableid = locDB.tbl.ctbl[locDB.const.rlm]
		locDB.tbl.id = tableid
		locDB.tbl.rlm.nme = mytable
		locDB.tbl.rlm.kills = mykilltable
		locDB.tbl.rlm.tmpkills = mytmpkilltable
		locDB.tbl.rlm.class = myclasstable
		msg = locDB.misc.currealm.." - "..strlower(class)
		PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	end
	if locDB.bool.class == true then
 		PKBlow:ClassSelect(locDB.ddDB.plcl)
		tableid = locDB.tbl.ctbl[locDB.const.class]
		locDB.tbl.id = tableid
	end
	if locDB.bool.splayer == true then
		PKBlow:SetPlayer()
		tableid = locDB.tbl.ctbl[locDB.const.players]
		locDB.tbl.id = tableid
	end
	if locDB.bool.ksorted == true then
		locDB.bool.ksorted = false
		local list = "kills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	elseif locDB.bool.tksorted == true then
		locDB.bool.tksorted = false
		local list = "tmpkills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	end
	PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)

end

function PKBlow:SetPlayer()

	local mytable = {}
	local mykilltable = {}
	local mytmpkilltable = {}
	local myclasstable = {}
	local nmeindex = 0
	local text = PKBlow_Search:GetText()
	local length = strlen(text)
	local pagenr = 1
	local player = ""
	local tableid = locDB.tbl.id
	for index, value in ipairs(locDB.tbl[tableid].nme) do
		local pattern = strfind	(locDB.tbl[tableid].nme[index], "%p")
		if pattern == nil then
			player = locDB.tbl[tableid].nme[index]
		else
			player = strsub(locDB.tbl[tableid].nme[index], 1, pattern - 1)
		end
		pattern = strsub(player, 1, length)
		if strlower(text) == strlower(pattern) then
			tinsert(mytable, locDB.tbl[tableid].nme[index])
			tinsert(mykilltable, locDB.tbl[tableid].kills[index])
			tinsert(mytmpkilltable, locDB.tbl[tableid].tmpkills[index])
			tinsert(myclasstable, locDB.tbl[tableid].class[index])
		end
	end
	locDB.tbl.players.nme = mytable
	locDB.tbl.players.kills = mykilltable
	locDB.tbl.players.tmpkills = mytmpkilltable
	locDB.tbl.players.class = myclasstable
	tableid = locDB.tbl.ctbl[locDB.const.players]
	locDB.tbl.id = tableid
	if locDB.bool.ksorted == true then
		locDB.bool.ksorted = false
		local list = "kills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	elseif locDB.bool.tksorted == true then
		locDB.bool.tksorted = false
		local list = "tmpkills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(locDB.misc.list)
	end
    PKBlow:NextPage(nmeindex, pagenr, mytable, mykilltable, mytmpkilltable, myclasstable)

end

-- check if player is in table, if he is, add the killing blow to tables,
-- if he's not, add player + killing blow
function PKBlow:NmeKillCounter(destname, playername, destclass, playerclass)

	local count = 1
	local match = false				         -- match if killed player is allready in nmetable
	local tmpkillcount = 0
	local destname = destname
	local playername = playername
	local destclass = destclass
	local playerclass = playerclass
	local npc = false
	for index, value in ipairs(pkbDB.npcfilterDB) do
		if destname == pkbDB.npcfilterDB[index] then
			npc = true
		end
	end
	if npc == false then
		PKBlow:Counter()
		if next(PKBlowDB) == nil then
			PKBlowDB[1] = {}
			tinsert(PKBlowDB[1], locDB.const.nme, destname)
			tinsert(PKBlowDB[1], locDB.const.class, destclass)
			tinsert(PKBlowDB[1], locDB.const.kills, count)
			tinsert(locDB.kills.tmpkilltable, count)
		else
			for index, value in ipairs(PKBlowDB) do
				if (PKBlowDB[index][locDB.const.nme] == destname) then
					count = PKBlowDB[index][locDB.const.kills] + 1
					PKBlowDB[index][locDB.const.kills] = count
					tmpkillcount = locDB.kills.tmpkilltable[index] + 1
					tinsert(locDB.kills.tmpkilltable, index, tmpkillcount)
					tremove(locDB.kills.tmpkilltable, (index + 1))
					match = true
				end
			end
			if match == false then
				local index = #PKBlowDB
				PKBlowDB[index + 1] = {}
				tinsert(PKBlowDB[index + 1], locDB.const.nme, destname)
				tinsert(PKBlowDB[index + 1], locDB.const.kills, count)
				tinsert(PKBlowDB[index + 1], locDB.const.class, destclass)
				tinsert(locDB.kills.tmpkilltable, count)
			end
		end
		match = false
		if pkbDB.optDB.showchatmsg == 1 then
			local kills = 0
			local totkills = 0
			local defaultmsg = ""
			local chatmsg = ""
			local _, _, _, destcolor = PKBlow:ClassColor(destclass)
			local _, _, _, playercolor = PKBlow:ClassColor(playerclass)
			for index, value in ipairs(PKBlowDB) do
				if destname == PKBlowDB[index][locDB.const.nme] then
					kills = PKBlowDB[index][locDB.const.kills]
					totkills = kills
					if kills == 1 then
						kills = kills.." "..L["kill"]
					else
						kills = kills.." "..L["kills"]
					end
				end
			end
			if pkbDB.optDB.custchat == 0 then
				for index, value in ipairs(pkbDB.settingsDB.chatDB) do
					if pkbDB.settingsDB.chatDB[index] ~= "DEFAULT" then
						chatmsg = "<PKBlow> "..playername.." -> "..L["Killing blow"].." -> "..destname.." - "..kills.." killing spree = "..pkbDB.kstreak
						SendChatMessage(chatmsg, pkbDB.settingsDB.chatDB[index])
					elseif pkbDB.settingsDB.chatDB[index] == "DEFAULT" then
						defaultmsg = locDB.fcolor.orangered.h.."<PKBlow> |r"..playercolor..playername.."|r"..locDB.fcolor.white.h.." ->|r "..locDB.fcolor.blzzyellow.h..L["Killing blow"].." |r"..locDB.fcolor.white.h.." ->|r "..destcolor..destname.."|r - "..locDB.fcolor.blzzyellow.h..kills.."|r killing spree = "..pkbDB.kstreak
						DEFAULT_CHAT_FRAME:AddMessage(defaultmsg)
					end
				end
			else
				for index, value in ipairs(pkbDB.settingsDB.chatDB) do
					if pkbDB.settingsDB.chatDB[index] ~= "DEFAULT" then
						local msg = PKBlow:CustChatFormat(totkills, nil, nil, nil)
						SendChatMessage(msg, pkbDB.settingsDB.chatDB[index])
					elseif pkbDB.settingsDB.chatDB[index] == "DEFAULT" then
						local msg = locDB.fcolor.orangered.h.."<PKBlow> |r"..PKBlow:CustChatFormat(totkills, true, playercolor, destcolor)
						DEFAULT_CHAT_FRAME:AddMessage(msg)
					end
				end
			end
		end
		local tableid = locDB.tbl.ctbl[locDB.const.nme]
		local _, pages, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
		PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
		local pagenr = pages
		locDB.misc.page = pagenr
		local nmeindex = PKBlow:GetNmeIndex(locDB.tbl[tableid].nme)
		locDB.tbl.id = tableid
		PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
	end

end

function PKBlow:ResetTables()

	local pagenr = 1
	local nmeindex = 0
	locDB.kills.totkblows = 0
	wipe(PKBlowDB)
	wipe(locDB.kills.tmpkilltable)
	PKBlow:KillCount()
	PKBlow:TotalKillMsg()
	PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
	PKBlow:NextPage(nmeindex, pagenr, locDB.tbl.nme.nme, locDB.tbl.nme.kills, locDB.tbl.nme.tmpkills, locDB.tbl.nme.class)

end

function PKBlow:DeletePlayer(npcname)

	local name = npcname
	local match = false
	for index, value in ipairs(PKBlowDB) do
		if strlower(name) == strlower(PKBlowDB[index][locDB.const.nme]) then
			tremove(PKBlowDB, index)
			tinsert(pkbDB.npcfilterDB, name)
			local pagenr = floor(index / locDB.const.MAXLINES) + 1
			local nmeindex = locDB.const.MAXLINES * (pagenr - 1)
			PKBlow:ClearFrames()
			PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
			PKBlow:NextPage(nmeindex, pagenr, locDB.tbl.nme.nme, locDB.tbl.nme.kills, locDB.tbl.nme.tmpkills, locDB.tbl.nme.class)
			match = true
		end
	end
	if match == false then
		if name == "" then
			print(locDB.fcolor.orangered.h.."PKBlow:|r \" \""..L[" not found"])
		else
			print(locDB.fcolor.orangered.h.."PKBlow:|r \""..name.."\""..L[" not found"])
		end
	end

end

function PKBlow:CreateTT(owner, anchor, xpos, ypos, msg)

	local owner, anchor, xpos, ypos, msg = owner, anchor, xpos, ypos, msg
	if pkbDB.optDB.showpkbtt == 1 then
		GameTooltip:SetOwner(owner, anchor, xpos, ypos)
		GameTooltip:AddLine(msg, 1, 1, 1)
		GameTooltip:Show()
	end

end

function PKBlow:GameTTHandler(nmeplayer)

	local nmeplayer = nmeplayer
--print("in tthandler, nmeplayer = "..tostring(nmeplayer))
	if pkbDB.optDB.showgamett == 1 then
--print("in tthandler, showgemtt = "..tostring(pkbDB.optDB.showgamett))
		for index, value in ipairs(PKBlowDB) do
			if nmeplayer == PKBlowDB[index][locDB.const.nme] then
				if PKBlowDB[index][locDB.const.kills] == 1 then
					GameTooltip:AddLine(locDB.fcolor.orangered.h.."PKB:|r "..locDB.fcolor.blzzyellow.h..tostring(PKBlowDB[index][locDB.const.kills]).." "..L["kill"])
				else
					GameTooltip:AddLine(locDB.fcolor.orangered.h.."PKB:|r "..locDB.fcolor.blzzyellow.h..tostring(PKBlowDB[index][locDB.const.kills]).." "..L["kills"])
				end
				locDB.misc.lastmouseover = nmeplayer 	-- prevents double printing
			end
		end
	end

end

--------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------

function PKBlow:SetFontWithFlags(frame, id,  fheight)

	local frame, id, fheight = frame, id, fheight
	local str = _G[frame]:GetName()
	str = _G[str]
	local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB[id][1], pkbDB.settingsDB.fntflDB[id][2], pkbDB.settingsDB.fntflDB[id][3]
	if fntfl1 then
		if fntfl3 then
			str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight, fntfl1, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight, fntfl1)
		end
	elseif fntfl2 then
		if fntfl3 then
			str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight, fntfl2, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight, fntfl2)
		end
	elseif fntfl3 and not fntfl1 and not fntfl2 then
		str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight)
	else
		str:SetFont(pkbDB.settingsDB.fontsDB[id], fheight)
	end

end

function PKBlow:CreateShowChangeFrame(frname, parent, bg, text, txtclr, frbg, width, height, xpos, ypos)

	local frname = frname
	local parent = parent
	local bg = bg
	local text = text
	local width, height = width, height
	local xpos, ypos = xpos, ypos
	local fheight = 13
	local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB.GUI[1], pkbDB.settingsDB.fntflDB.GUI[2], pkbDB.settingsDB.fntflDB.GUI[3]
	local name = "PKBlow_"..frname.."BgChangeFrame"
	local strname = "PKBlow_"..frname.."FontChangeStr"
	local fr = locDB.calls.api.createframe("Frame", name, _G[parent])
	local frbg = frbg or {
		bgFile = pkbDB.settingsDB.guiDB[bg],
		edgeFile = pkbDB.settingsDB.guiDB.border,
		tile = false,
		tileSize = 16,
		edgeSize = pkbDB.settingsDB.guiDB.edgesize,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3,
		},
	},
	fr:SetHeight(height)
	fr:SetWidth(width)
	fr:SetPoint("TOPLEFT", _G[parent], xpos, ypos)
	fr:SetBackdrop(frbg)
	local str = fr:CreateFontString(strname, "ARTWORK", nil)
--~ 	PKBlow:SetFontWithFlags(strname, "GUI", fheight)
	if fntfl1 then
		if fntfl3 then
			str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight, fntfl1, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight, fntfl1)
		end
	elseif fntfl2 then
		if fntfl3 then
			str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight, fntfl2, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight, fntfl2)
		end
	elseif fntfl3 and not fntfl1 and not fntfl2 then
		str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight)
	else
		str:SetFont(pkbDB.settingsDB.fontsDB.GUI, fheight)
	end
	str:SetJustifyH("CENTER")
	if frname == "mbg" then
		str:SetPoint("TOP", fr, "CENTER", 0, 25)
	else
		str:SetPoint("CENTER", fr, "CENTER", 0, 0)
	end
	str:SetTextColor(locDB.fcolor[txtclr].r, locDB.fcolor[txtclr].g, locDB.fcolor[txtclr].b, 1)
	str:SetText(text)

end

function PKBlow:CreateDemoKillingBlowMessageFrame()

	local fheight = 32
	local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB.Kb[1], pkbDB.settingsDB.fntflDB.Kb[2], pkbDB.settingsDB.fntflDB.Kb[3]
	local pkblowkbmsgfr = locDB.calls.api.createframe("Frame", "PKBlow_DemoKbMessageChangeFrame", PKBlow_Panel_KbAnnounce)
	local bg = {
			bgFile = locDB.ddDB.bg[2][1],
			edgeFile = locDB.ddDB.border[1][1],
			tile = false,
			tileSize = 16,
			edgeSize = 16,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3,
			}
		}
	pkblowkbmsgfr:SetPoint("TOPLEFT",  PKBlow_Panel_KbAnnounce, 40 , -125 )
	pkblowkbmsgfr:SetWidth(374)
	pkblowkbmsgfr:SetHeight(60)
	pkblowkbmsgfr:SetBackdrop(bg)
	local strname = "PKBlow_DemoKbMessageChangeFrameStr"
	local str = pkblowkbmsgfr:CreateFontString(strname , "ARTWORK", nil)
	if fntfl1  then
		if fntfl3  then
			str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight, fntfl1, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight, fntfl1)
		end
	elseif fntfl2  then
		if fntfl3 then
			str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight, fntfl2, fntfl3)
		else
			str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight, fntfl2)
		end
	elseif fntfl3 and not fntfl1 and not fntfl2 then
		str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight)
	else
		str:SetFont(pkbDB.settingsDB.fontsDB.Kb, fheight)
	end
	str:SetJustifyH("CENTER")
	str:SetPoint("CENTER", pkblowkbmsgfr, "CENTER", 0, -2)
	str:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
	str:SetText(L["Killing blow"])

end

function PKBlow:SortTable()     -- Sort emotes alfabeticaly

	sort(locDB.ddDB.emotes, function(a,b) return strlower(a[1]) < strlower(b[1]) end)

end

-------------------------------------------------------------------------
------------ Dropdown constructors --------------------------------------
-------------------------------------------------------------------------
function PKBlow:CreateDDHeaderFrame(frname, frtxt, parentpanel, width, height, frx, fry)

	local frname = frname
	local frtxt = frtxt
	local parentpanel = parentpanel
	local frx, fry = frx, fry
	local titlefr = "PKBlow_"..frname.."TitleFrame"
	local ddfr = "PKBlow_"..frname.."List"
	local ddbgfr = "PKBlow_"..frname.."DdBg"
	local titlearrow = "PKBlow_"..frname.."TitleFrameExpandArrow"
	local ddtitlefr = locDB.calls.api.createframe("Frame", titlefr, _G[parentpanel])
	ddtitlefr:SetWidth(width)
	ddtitlefr:SetHeight(height)
	ddtitlefr:SetPoint("TOPLEFT", _G[parentpanel], frx, fry)
	local bg = {}
	if frname == "plclass" then
		bg = {
			bgFile = locDB.ddDB.bg[4][1],
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		}
	else
		bg = {
			bgFile = locDB.ddDB.bg[3][1],
			edgeFile = locDB.ddDB.border[1][1],
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		}
	end
	ddtitlefr:SetBackdrop(bg)
	local ftitlestring = _G[titlefr]:CreateFontString(titlefr.."Str", "ARTWORK", "GameFontNormalSmall")
	ftitlestring:SetJustifyH("CENTER")
	ftitlestring:SetPoint("CENTER", titlefr, "CENTER", 0, 0)
	ftitlestring:SetTextColor(1, 1, 1, 1)
	if frname == "plclass" then
		ftitlestring:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	end
	PKBlow:SetFontWithFlags(titlefr.."Str", "GUI", 11)
	ftitlestring:SetText(frtxt)
	local fexpandarrow = locDB.calls.api.createframe("Button", titlearrow, _G[titlefr])
	fexpandarrow:SetWidth(22)
	fexpandarrow:SetHeight(22)
	fexpandarrow:SetPoint("RIGHT", titlefr, -2, 0)
	fexpandarrow:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
	fexpandarrow:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	fexpandarrow:SetScript("OnClick", function(self, button, down)
		if _G[ddfr]:IsVisible() then
			_G[ddfr]:Hide()
			_G[ddbgfr]:Hide()
		else
			_G[ddfr]:Show()
			_G[ddbgfr]:Show()
		end
	end)

end

function PKBlow:CreateDDFrame(scrfrname, parentpanel, maxentries, width, height, ypos)

	local scrfrname = scrfrname
	local parentpanel = parentpanel
	local width = width
	local height = height
	local xpos = 0
	local ypos = ypos
	local maxentries = maxentries
	local titlefr = "PKBlow_"..scrfrname.."TitleFrame"
	local scrfr = "PKBlow_"..scrfrname.."List"
	local ddbgfr = "PKBlow_"..scrfrname.."DdBg"
	local ddfr = locDB.calls.api.createframe("Frame", scrfr, _G[parentpanel])
	ddfr:SetFrameStrata("TOOLTIP")
	ddfr:SetPoint("TOPLEFT", titlefr, xpos, ypos)
	ddfr:SetWidth(width)
	ddfr:SetHeight(height * maxentries)
	ddfr:Hide()
	local ddbg = locDB.calls.api.createframe("Frame", ddbgfr, _G[parentpanel])
	ddbg:SetWidth(width)
	ddbg:SetHeight((height * maxentries) + 8)
	ddbg:SetPoint("TOPLEFT", titlefr, xpos, ypos + 5)
	local bg = {}
	if scrfrname == "plclass" then
		bg = {
			bgFile = locDB.ddDB.bg[4][1],
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		}
	else
		bg = {
			bgFile = locDB.ddDB.bg[4][1],
			edgeFile = locDB.ddDB.border[1][1],
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		}
	end
	ddbg:SetBackdrop(bg)
	ddbg:Hide()

end

function PKBlow:CreateDDChild(scrfrname, locdb, maxentries, width, height, ypos)

	local scrfrname, locdb = scrfrname, locdb
	local maxentries = maxentries
	local width = width
	local height = height
	local ypos = ypos
	local index = 1
	while maxentries ~= 0 do
		local strname = "PKBlow_"..scrfrname.."Str"
		local btnname = "PKBlow_"..scrfrname.."Button"
		local titlefr = "PKBlow_"..scrfrname.."TitleFrame"
		local scrfr = "PKBlow_"..scrfrname.."List"
		local ddchbtn = locDB.calls.api.createframe("Button", btnname..index, _G[scrfr], nil)
		ddchbtn:EnableMouse(true)
		ddchbtn:SetFrameStrata("TOOLTIP")
		ddchbtn:SetWidth(width)
		ddchbtn:SetPoint("TOPLEFT", titlefr, 4, ypos)
		ddchbtn:SetHeight(height)
		ddchbtn:SetHighlightTexture(locDB.ddDB.bg[5][1])
		local ddchstr = ddchbtn:CreateFontString(strname..index, "ARTWORK", "GameFontNormal")
		ddchstr:SetJustifyH("CENTER")
		ddchstr:SetPoint("CENTER", ddchbtn, "CENTER", 0, 0)
		ddchstr:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		PKBlow:SetFontWithFlags(strname..index, "GUI", 12)
		if scrfrname == "chatchan" or scrfrname == "plclass" then
			ddchstr:SetText(locDB.ddDB[locdb][index][1])
		else
			ddchstr:SetText(locDB.ddDB[locdb][index][2])
		end
		maxentries = maxentries - 1
		index = index + 1
		ypos = ypos - height
	end

end

function PKBlow:InitializeDD(frname, pkbdb, locdb, fntdb, haspkbdb)

	local frname = frname
	local pkbdb = pkbdb
	local locdb = locdb
	local fntdb =  fntdb
	local haspkbdb = haspkbdb
	if haspkbdb and locdb ~= "border" then
		local count = #locDB.ddDB[locdb]
		for i = 1, count do
			local ddchbtn = "PKBlow_"..frname.."Button"..i
			local ddchstr = "PKBlow_"..frname.."Str"..i
			_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
			_G[ddchstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
		end
		if fntdb then
			for index, value in ipairs(pkbDB.settingsDB[pkbdb][fntdb]) do
				local ddchbtn = "PKBlow_"..frname.."Button"..index
				local ddchstr = "PKBlow_"..frname.."Str"..index
				local btnstr = locDB.ddDB[locdb][index][1]
				if pkbDB.settingsDB[pkbdb][fntdb][index] and pkbDB.settingsDB[pkbdb][fntdb][index] == btnstr then
					_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
					_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
				end
			end
		else
			local db = locDB.ddDB[locdb]
			local count = #db
			for index, value in ipairs(db) do
				local ddchbtn = "PKBlow_"..frname.."Button"..index
				local ddchstr = "PKBlow_"..frname.."Str"..index
				local btnstr = locDB.ddDB[locdb][index][1]
				local setmatch = locDB.ddDB[locdb][index][2]
				for index2, value2 in ipairs(pkbDB.settingsDB[pkbdb]) do
					if setmatch == pkbDB.settingsDB[pkbdb][index2] then
						_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
						_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
					end
				end
			end
		end
	else
		local count = #locDB.ddDB[locdb]
		for i = 1, count do
			local ddchbtn = "PKBlow_"..frname.."Button"..i
			local ddchstr = "PKBlow_"..frname.."Str"..i
			_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
			_G[ddchstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
		end
		local setmatch = ""
		if pkbdb == "plcl" then
		 	setmatch = locDB.ddDB[pkbdb]
		else
 			setmatch = pkbDB.settingsDB[pkbdb][locdb]
		end
		for index, value in ipairs(locDB.ddDB[locdb]) do
			local ddchbtn = "PKBlow_"..frname.."Button"..index
			local ddchstr = "PKBlow_"..frname.."Str"..index
			local btnstr = strlower(locDB.ddDB[locdb][index][1])
			if btnstr == strlower(setmatch) then
				_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
				_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
			else
				_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
				_G[ddchstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			end
		end
	end

end

function PKBlow:OnClickDD(frname, maxentries, pkbdb, locdb, frid, haspkbdb)

	local haspkbdb = haspkbdb
	local frname = frname
	local maxentries = maxentries
	local pkbdb = pkbdb
	local locdb = locdb
	local frid = frid
	local btnname = "PKBlow_"..frname.."Button"
	local strname = "PKBlow_"..frname.."Str"
	for index = 1, maxentries do
		local fbtn = btnname..index
		local fstr = strname..index
		_G[fbtn]:SetScript("OnClick", function(self, button, down)
			PKBlow:DDClickedHandler(frname, fstr, pkbdb, locdb, frid, fbtn, index)
		end)
	end

end

function PKBlow:DDClickedHandler(frname, ddchstr, pkbdb, locdb, frid, ddchbtn, frnr)

	local frname = frname
	local ddchbtn = ddchbtn
	local ddchstr = ddchstr
	local pkbdb = pkbdb
	local locdb = locdb
	local frid = frid
	local frnr = frnr
	if locdb == "plclass"then
		local newclass = _G[ddchstr]:GetText()
		local nmeindex = 0
		local pagenr = 1
		local count = #locDB.ddDB.plclass
		local tableid = locDB.tbl.id
		locDB.ddDB.plcl = newclass
		locDB.bool.class = false
		for i = 1, count do
			local curbtn = "PKBlow_"..frname.."Button"..i
			local curstr = "PKBlow_"..frname.."Str"..i
			_G[curstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			_G[curbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
		end
		for index, value in ipairs(locDB.ddDB.plclass) do
			if locDB.ddDB.plcl == locDB.ddDB.plclass[index][1] then
				_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
				_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
				PKBlow:ClassSelect(locDB.ddDB.plclass[index][2])
				if locDB.bool.splayer == true then
					PKBlow:SetPlayer()
				end
				if locDB.bool.ksorted == true then
					locDB.bool.ksorted = false
					local list = "kills"
					locDB.misc.list = list
					PKBlow:KillSortHandler(locDB.misc.list)
				elseif locDB.bool.tksorted == true then
					locDB.bool.tksorted = false
					local list = "tmpkills"
					locDB.misc.list = list
					PKBlow:KillSortHandler(locDB.misc.list)
				end
			end
		end
		if locDB.bool.splayer == true or locDB.bool.getrealm == true then
			PKBlow_Search:SetFocus()
		end
	elseif locdb == "fntflag" then
		local btntxt = strupper(_G[ddchstr]:GetText())
		local count = #locDB.ddDB[locdb]
		if btntxt == pkbDB.settingsDB[pkbdb][frid][frnr] then
			pkbDB.settingsDB[pkbdb][frid][frnr] = false
			_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
			_G[ddchstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
		else
			pkbDB.settingsDB[pkbdb][frid][frnr] = btntxt
			_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
			_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
			if frnr == 1 then
				pkbDB.settingsDB[pkbdb][frid][2] = false
				_G["PKBlow_"..frname.."Button2"]:SetNormalTexture(locDB.ddDB.bg[4][1])
				_G["PKBlow_"..frname.."Str2"]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			elseif frnr == 2 then
				pkbDB.settingsDB[pkbdb][frid][1] = false
				_G["PKBlow_"..frname.."Button1"]:SetNormalTexture(locDB.ddDB.bg[4][1])
				_G["PKBlow_"..frname.."Str1"]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			end
		end
		if frid == "GUI" then
			_G["PKBlow_mbgBgChangeFrame"]:Hide()
			_G["PKBlow_cbgBgChangeFrame"]:Hide()
			_G["PKBlow_mbgBgChangeFrame"] = nil
			_G["PKBlow_cbgBgChangeFrame"] = nil
			local mbgchangefr = PKBlow:CreateShowChangeFrame("mbg", "PKBlow_Panel_UI", "mbg", " "..addonname.." v".. version, "orangered", nil, 374, 75, 40, -115)
			local cbgchangefr = PKBlow:CreateShowChangeFrame("cbg", "PKBlow_mbgBgChangeFrame", "cbg", "All classes - all realms", "blzzyellow", nil, 334, 30, 22, -30)
			_G["PKBlow_mbgBgChangeFrame"]:Show()
			_G["PKBlow_cbgBgChangeFrame"]:Show()
		else
			_G["PKBlow_DemoKbMessageChangeFrame"]:Hide()
			_G["PKBlow_DemoKbMessageChangeFrame"] = nil
			local createdkfr = PKBlow:CreateDemoKillingBlowMessageFrame()
			_G["PKBlow_DemoKbMessageChangeFrame"]:Show()
		end
	elseif locdb == "chatchan" then
		local btntxt = _G[ddchstr]:GetText()
		local setmatch = ""
		local match = false
		for i = 1, #locDB.ddDB.chatchan do
			if btntxt == locDB.ddDB.chatchan[i][1] then
				setmatch = locDB.ddDB.chatchan[i][2]
			end
			for j = 1, #pkbDB.settingsDB.chatDB do
				if setmatch == pkbDB.settingsDB[pkbdb][j] then
					_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
					_G[ddchstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
					tremove(pkbDB.settingsDB[pkbdb],j)
					match = true
				end
			end
		end
		if match == false then
			for index, value in ipairs(locDB.ddDB.chatchan) do
				if btntxt == locDB.ddDB.chatchan[index][1] then
					btntxt = locDB.ddDB.chatchan[index][2]
				end
			end
			_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
			_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
			tinsert(pkbDB.settingsDB[pkbdb], btntxt)
		end
	else
		local btntxt = _G[ddchstr]:GetText()
		local count = #locDB.ddDB[locdb]
		for i = 1, count do
			local curbtn = "PKBlow_"..frname.."Button"..i
			local curstr = "PKBlow_"..frname.."Str"..i
			_G[curstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			_G[curbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
		end
		for i = 1, count do
			if btntxt == locDB.ddDB[frname][i][2] then
				pkbDB.settingsDB[pkbdb][frname] = locDB.ddDB[frname][i][1]
				_G[ddchbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
				_G[ddchstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
				_G["PKBlow_mbgBgChangeFrame"]:Hide()
				_G["PKBlow_cbgBgChangeFrame"]:Hide()
				_G["PKBlow_mbgBgChangeFrame"] = nil
				_G["PKBlow_cbgBgChangeFrame"] = nil
				local changefr = PKBlow:CreateShowChangeFrame("mbg", "PKBlow_Panel_UI", "mbg", " "..addonname.." v".. version, "orangered", nil, 374, 75, 40, -115)
				local changefr = PKBlow:CreateShowChangeFrame("cbg", "PKBlow_mbgBgChangeFrame", "cbg", "All classes - all realms", "blzzyellow", nil, 334, 30, 22, -30)
				_G["PKBlow_mbgBgChangeFrame"]:Show()
				_G["PKBlow_cbgBgChangeFrame"]:Show()
			end
		end
	end

end

--------------------------------------------------
--------------------------------------------------
-------  scrollable dropdownmenuconstructors -----
--------------------------------------------------
--------------------------------------------------

function PKBlow:MyScrollList_Update(scrfr, scrfrname, pkbdb, locdb, maxentries)

	local scrfr = scrfr
	local scrfrname = scrfrname
	local pkbdb = pkbdb
	local locdb = locdb
	local maxentries = maxentries
	local line = 1
	local lineplusoffset = 0
	local match = false
	local curstr = pkbDB.settingsDB[pkbdb][scrfrname]
	local count = #locDB.ddDB[locdb]
	FauxScrollFrame_Update(_G[scrfr], count, maxentries, 18)
	for line = 1, maxentries do
		local fr = "PKBlow_"..scrfrname.."Button"..line
		local fstr = "PKBlow_"..scrfrname.."Str"..line
		local btntxt = _G[fstr]:GetText()
		lineplusoffset = line + FauxScrollFrame_GetOffset(_G[scrfr])
		if lineplusoffset <= count then
			if locdb == "fonts"then
				_G[fstr]:SetFont(locDB.ddDB[locdb][lineplusoffset][1], 13, pkbDB.settingsDB.fntflDB.GUI[1], pkbDB.settingsDB.fntflDB.GUI[2], pkbDB.settingsDB.fntflDB.GUI[3])
				_G[fstr]:SetText(locDB.ddDB[locdb][lineplusoffset][2])
			else
				_G[fstr]:SetText(locDB.ddDB[locdb][lineplusoffset][2])
			end
			_G[fr]:Show()
		else
			_G[fr]:Hide()
		end
	end
	for i = 1, count do
		if curstr == locDB.ddDB[locdb][i][1] then
			curstr = locDB.ddDB[locdb][i][2]
		end
	end
	for line = 1, maxentries do
		local fstr = "PKBlow_"..scrfrname.."Str"..line
		local fbtn = "PKBlow_"..scrfrname.."Button"..line
		local btntxt = _G[fstr]:GetText()
		if curstr == btntxt and match == false then
			_G[fbtn]:SetNormalTexture(locDB.ddDB.bg[5][1])
			_G[fstr]:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
			_G[fbtn]:SetFrameStrata("TOOLTIP")
			match = true
		else
			_G[fbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
			_G[fstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			_G[fbtn]:EnableMouse(true)
		end
	end

end

function PKBlow:MyFauxScrollFrame_OnVerticalScroll(self, offset, maxentries, pkbdb, locdb, height, srcfrname)

	local self = self
	local offset = offset
	local maxentries = maxentries
	local pkdb = pkdb
	local locdb = locdb
	local height = height
	local srcfrname = srcfrname
	local selfname = self:GetName()
	local scrollbar = _G[selfname.."ScrollBar"]
	scrollbar:SetValue(offset)
	self.offset = floor((offset / height) + 0.5)
	PKBlow:MyScrollList_Update("PKBlow_"..srcfrname.."List", srcfrname, pkbdb, locdb, maxentries)

end

function PKBlow:CreateScrollFrame(scrfrname, parentpanel, maxentries, pkbdb, locdb, width, height, ypos)

	local scrfrname = scrfrname
	local parentpanel = parentpanel
	local locdb = locdb
	local pkbdb = pkbdb
	local maxentries = maxentries
	local width = width
	local height = height * maxentries
	local xpos, ypos = 0, ypos
	local titlefr = "PKBlow_"..scrfrname.."TitleFrame"
	local scrfr = "PKBlow_"..scrfrname.."List"
	local ddbgfr = "PKBlow_"..scrfrname.."DdBg"
	local ddfr = locDB.calls.api.createframe("ScrollFrame", scrfr, parentpanel, "FauxScrollFrameTemplate")
	ddfr:SetWidth(width)
	ddfr:SetHeight(height)
	ddfr:SetPoint("TOPLEFT", titlefr, xpos + 1, ypos)
	ddfr:Hide()
	ddfr:SetScript("OnShow", function (self)
		ddfr:SetFrameStrata("TOOLTIP")
		PKBlow:MyScrollList_Update(scrfr, scrfrname, pkbdb, locdb, maxentries)
	end)
	ddfr:SetScript("OnVerticalScroll", function(self, offset)
		PKBlow:MyFauxScrollFrame_OnVerticalScroll(self, offset, maxentries, pkbdb, locdb, 18, scrfrname)
	end)
	local ddbg = locDB.calls.api.createframe("Frame", ddbgfr,ddfr)
	ddbg:SetFrameStrata("TOOLTIP")
	ddbg:SetWidth(width + 28)
	ddbg:SetHeight(height + 9)
	ddbg:SetPoint("TOPLEFT", titlefr, xpos, ypos + 5)
	local bg = {
		bgFile = locDB.ddDB.bg[4][1],
		edgeFile = locDB.ddDB.border[1][1],
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddbg:SetBackdrop(bg)
	ddbg:Hide()

end

function PKBlow:CreateScrollableDDChild(frname, maxentries, pkbdb, locdb, width, height, ypos)

	local frname = frname
	local maxentries = maxentries
	local pkbdb = pkbdb
	local locdb = locdb
	local count = maxentries
	local height = height
	local ypos = ypos
	local fheight = 32
	local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB.Kb[1], pkbDB.settingsDB.fntflDB.Kb[2], pkbDB.settingsDB.fntflDB.Kb[3]
	local index = 1
	while count ~= 0 do
		local strname = "PKBlow_"..frname.."Str"
		local btnname = "PKBlow_"..frname.."Button"
		local titlefr = "PKBlow_"..frname.."TitleFrame"
		local scrfr = "PKBlow_"..frname.."List"
			local ddbtn = locDB.calls.api.createframe("Button", btnname..index, _G[scrfr], nil)
			ddbtn:EnableMouse(true)
			ddbtn:SetHeight(height)
			ddbtn:SetWidth(width + 32)
			ddbtn:SetPoint("TOPLEFT", titlefr, 3, ypos - 2)
			ddbtn:SetNormalTexture(locDB.ddDB.bg[4][1])
			ddbtn:SetHighlightTexture(locDB.ddDB.bg[5][1])
			local ddstr = ddbtn:CreateFontString(strname..index, "ARTWORK", "GameFontNormal")
			ddstr:SetJustifyH("CENTER")
			ddstr:SetPoint("CENTER", ddbtn, "CENTER", 1, 0)
			ddstr:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
			if locdb == "fonts" then
				PKBlow:SetFontWithFlags(strname..index, "GUI" ,13)
			else
				PKBlow:SetFontWithFlags(strname..index, "GUI", 12)
			end
			ddstr:SetText(locDB.ddDB.fonts[index][2])
			ddbtn:SetScript("OnClick", function(self, button, down)
				local font = ddstr:GetFont()
				local btntxt = ddstr:GetText()
				for i = 1, maxentries do
					local fbtn = btnname..i
					local fstr = strname..i
					_G[fbtn]:SetNormalTexture(locDB.ddDB.bg[4][1])
					_G[fstr]:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
				end
				ddbtn:SetNormalTexture(locDB.ddDB.bg[5][1])
				ddstr:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
				if frname == "Kb"then
					_G["PKBlow_DemoKbMessageChangeFrame"]:Hide()
					_G["PKBlow_DemoKbMessageChangeFrameStr"] = nil
					_G["PKBlow_DemoKbMessageChangeFrame"] = nil
					pkbDB.settingsDB[pkbdb][frname] = font
					local changefr = PKBlow:CreateDemoKillingBlowMessageFrame()
					_G["PKBlow_DemoKbMessageChangeFrame"]:Show()
				elseif frname == "GUI" then
					_G["PKBlow_mbgBgChangeFrame"]:Hide()
					_G["PKBlow_cbgBgChangeFrame"]:Hide()
					_G["PKBlow_mbgBgChangeFrame"] = nil
					_G["PKBlow_cbgBgChangeFrame"] = nil
					pkbDB.settingsDB[pkbdb][frname] = font
					local changefr = PKBlow:CreateShowChangeFrame("mbg", "PKBlow_Panel_UI", "mbg", " "..addonname.." v".. version, "orangered", nil, 374, 75, 40, -115)
					local changefr = PKBlow:CreateShowChangeFrame("cbg", "PKBlow_mbgBgChangeFrame", "cbg", "All classes - all realms", "blzzyellow", nil, 334, 30, 22, -30)
					_G["PKBlow_mbgBgChangeFrame"]:Show()
					_G["PKBlow_cbgBgChangeFrame"]:Show()
				else
					local count = #locDB.ddDB[locdb]
					for i = 1, count do
						if btntxt == locDB.ddDB[locdb][i][2] then
							pkbDB.settingsDB[pkbdb][frname] = locDB.ddDB[locdb][i][1]
							local bgfile = pkbDB.settingsDB[pkbdb][frname]
							local bg = {
								bgFile = bgfile,
								edgeFile = pkbDB.settingsDB.guiDB.border,
								tile = false,
								tileSize = 16,
								edgeSize = pkbDB.settingsDB.guiDB.edgesize,
								insets = {
									left = 3,
									right = 4,
									top = 4,
									bottom = 3,
								},
							}
							_G["PKBlow_"..frname.."BgChangeFrame"]:Hide()
							_G["PKBlow_"..frname.."BgChangeFrame"] = nil
							if frname == "mbg" then
								PKBlow:CreateShowChangeFrame(frname, "PKBlow_Panel_UI", frname, " "..addonname.." v".. version, "orangered", bg, 374, 75, 40, -115)
							_G["PKBlow_cbgBgChangeFrame"]:Hide()
							_G["PKBlow_cbgBgChangeFrame"] = nil
								PKBlow:CreateShowChangeFrame("cbg", "PKBlow_mbgBgChangeFrame", "cbg", "All classes - all realms", "blzzyellow", nil, 334, 30, 22, -30)
							elseif frname == "cbg" then
								PKBlow:CreateShowChangeFrame(frname, "PKBlow_mbgBgChangeFrame", frname, "All classes - all realms", "blzzyellow", bg, 334, 30, 22, -30)
							end
							_G["PKBlow_"..frname.."BgChangeFrame"]:Show()
						end
					end
				end
			end)
		count = count - 1
		index = index + 1
		ypos = ypos - height
	end

end

--------------------------------------------------------------------------------------------
------------ Emotesdropdown constructors ---------------------------------------------------
--------------------------------------------------------------------------------------------

function PKBlow:CreateEmoDDHeaderFrame(frname, frtxt, parentpanel, width, height, frx, fry)

	local frname = frname
	local frnr = tonumber(strsub(frname, 4))
	local frtxt = frtxt.." "..frnr
	local parentpanel = parentpanel
	local frx, fry = frx, fry
	local count = #locDB.ddDB.emotes
	local hcount = floor(count / locDB.maxentries) + 1
	local titlefr = "PKBlow_"..frname.."TitleFrame"
	local ddfr = "PKBlow_"..frname.."List"
	local ddbgfr = "PKBlow_"..frname.."DdBg"
	local titlearrow = "PKBlow_"..frname.."TitleFrameExpandArrow"
	local ddtitlefr = CreateFrame("Frame", titlefr, _G[parentpanel])
	ddtitlefr:SetWidth(width)
	ddtitlefr:SetHeight(height)
	ddtitlefr:SetPoint("TOPLEFT", _G[parentpanel], frx, fry)
	local bg = {
		bgFile = "Interface\\TutorialFrame\\TutorialFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddtitlefr:SetBackdrop(bg)
	local ftitlestring = _G[titlefr]:CreateFontString(titlefr.."Str", "ARTWORK", "GameFontNormalSmall")
	ftitlestring:SetJustifyH("CENTER")
	ftitlestring:SetPoint("CENTER", titlefr, "CENTER", 0, 0)
	ftitlestring:SetTextColor(1, 1, 1, 1)
	PKBlow:SetFontWithFlags(titlefr.."Str", "GUI", 12)
--	ftitlestring:SetFont("Fonts\\FRIZQT__.TTF", 11)
	ftitlestring:SetText(frtxt)
	local fexpandarrow = CreateFrame("Button", titlearrow, _G[titlefr])
	fexpandarrow:SetWidth(22)
	fexpandarrow:SetHeight(22)
	fexpandarrow:SetPoint("RIGHT", titlefr, -2, 0)
	fexpandarrow:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
	fexpandarrow:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD")
	fexpandarrow:SetScript("OnClick", function(self, button, down)
		if _G[ddfr]:IsVisible() then
			_G[ddfr]:Hide()
			_G[ddbgfr]:Hide()
 			if frnr < 10 then
				local mfrnr = frnr + locDB.maxrows
				local mfr = strsub(frname, 1, 3)
				while mfrnr < hcount + 1 do
					local tfr = "PKBlow_"..mfr..mfrnr.."TitleFrame"
					_G[tfr]:Show()
					mfrnr = mfrnr + locDB.maxrows
				end
			end
		else
			_G[ddfr]:Show()
			_G[ddbgfr]:Show()
			if tonumber(frnr) < 10 then
				local mfrnr = frnr + locDB.maxrows
				local mfr = strsub(frname, 1, 3)
				while tonumber(mfrnr) < hcount + 1 do
					local tfr = "PKBlow_"..mfr..mfrnr.."TitleFrame"
					local fr = "PKBlow_"..mfr..mfrnr.."List"
					local bgfr  = "PKBlow_"..mfr..mfrnr.."DdBg"
					_G[tfr]:Hide()
					_G[fr]:Hide()
					_G[bgfr]:Hide()
					mfrnr = mfrnr + locDB.maxrows
				end
			end
		end
	end)

end

function PKBlow:CreateEmoDDFrame(frname, frcount, parentpanel, width, height, ypos)

	local frname = frname
	local frcount = frcount
	local parentpanel = parentpanel
	local width = width
	local height = height
	local xpos = 0
	local ypos = ypos
	local count = #locDB.ddDB.emotes
	local maxentries = locDB.maxentries
	local hcount = floor(count / maxentries)
	local rest = count - (hcount * maxentries)
	if frcount > hcount then
		maxentries = rest
	end
	local titlefr = "PKBlow_"..frname.."TitleFrame"
	local fr = "PKBlow_"..frname.."List"
	local ddbgfr = "PKBlow_"..frname.."DdBg"
	local ddfr = CreateFrame("Frame", fr, _G[parentpanel])
	ddfr:SetFrameStrata("TOOLTIP")
	ddfr:SetPoint("TOPLEFT", titlefr, xpos, ypos)
	ddfr:SetWidth(width)
	ddfr:SetHeight(height * maxentries)
	ddfr:Hide()
	local ddbg = CreateFrame("Frame", ddbgfr, _G[parentpanel])
	ddbg:SetWidth(width)
	ddbg:SetHeight((height * maxentries) + 8)
	ddbg:SetPoint("TOPLEFT", titlefr, xpos, ypos + 5)
	local bg = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3
		}
	}
	ddbg:SetBackdrop(bg)
	ddbg:Hide()

end

function PKBlow:CreateEmoDDChild(frname, frcount, width, height, ypos)

	local frname = frname
	local frcount = frcount
	local width = width
	local height = height
	local ypos = ypos
	local start = ((frcount - 1) * locDB.maxentries) + 1
	local stop = #locDB.ddDB.emotes
	for i = 1, locDB.maxentries do
		if start > stop then return end
		local strname = "PKBlow_"..frname.."Str"
		local btnname = "PKBlow_"..frname.."Button"
		local titlefr = "PKBlow_"..frname.."TitleFrame"
		local listfr = "PKBlow_"..frname.."List"
		local ddchbtn = CreateFrame("Button", btnname..i, _G[listfr], nil)
		ddchbtn:EnableMouse(true)
		ddchbtn:SetFrameStrata("TOOLTIP")
		ddchbtn:SetWidth(width)
		ddchbtn:SetPoint("TOPLEFT", titlefr, 4, ypos)
		ddchbtn:SetHeight(height)
		ddchbtn:SetHighlightTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
		local ddchstr = ddchbtn:CreateFontString(strname..i, "ARTWORK", "GameFontNormal")
		ddchstr:SetJustifyH("CENTER")
		ddchstr:SetPoint("CENTER", ddchbtn, "CENTER", 0, 0)
		PKBlow:SetFontWithFlags(strname..i, "GUI", 12)
		ddchstr:SetTextColor(1, 0.8196079, 0, 1)
		ddchstr:SetText(strsub(locDB.ddDB.emotes[start][1], 2))
		start = start + 1
		ypos = ypos - height
	end

end

function PKBlow:InitializeEmoDD(frname, frcount)

	local frname = frname
	local frcount = frcount
	local frnr = tonumber(strsub(frname, 4) - 1)
	local maxentries = locDB.maxentries
	local count = #locDB.ddDB.emotes
	local hcount = floor(count / maxentries)
	local rest = count - (hcount * maxentries)
	if frcount > hcount then
		maxentries = rest
	end
	for i = 1, maxentries do
		local match = false
		local ddchstr = "PKBlow_"..frname.."Str"..i
		local ddchbtn = "PKBlow_"..frname.."Button"..i
		for index, value in ipairs(pkbDB.settingsDB.emotestokensDB) do
			local setmatch = pkbDB.settingsDB.emotestokensDB[index]
			if locDB.ddDB.emotes[i + (frnr * locDB.maxentries)][2] == setmatch then
				match = true
				_G[ddchbtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
				_G[ddchstr]:SetTextColor(1, 0.8196079, 0, 1)
			else
				if match == false then
					_G[ddchbtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Background-Dark")
					_G[ddchstr]:SetTextColor(1, 0.27, 0, 1)
				end
			end
		end
	end

end

function PKBlow:OnClickEmoDD(frname, frcount)

	local frname = frname
	local frcount = frcount
	local maxentries = locDB.maxentries
	local frnr = (tonumber(strsub(frname, 4)) - 1)	* maxentries
	local count = #locDB.ddDB.emotes
	local hcount = floor(count / maxentries)
	local rest = count - (hcount * maxentries)
	if frcount > hcount then
		maxentries = rest
	end
	local btnname = "PKBlow_"..frname.."Button"
	local strname = "PKBlow_"..frname.."Str"
	for index = 1, maxentries do
		local fbtn = btnname..index
		local fstr = strname..index
		_G[fbtn]:SetScript("OnClick", function(self, button, down)
			PKBlow:EmoDDClickedHandler(frname, fstr, fbtn, index + frnr)
		end)
	end

end

function PKBlow:EmoDDClickedHandler(frname, ddchstr, ddchbtn, frnr)

	local frname = frname
	local ddchbtn = ddchbtn
	local ddchstr = ddchstr
	local frnr = frnr
	local match = false
	local i = 0
	for index, value in ipairs (pkbDB.settingsDB.emotestokensDB) do
		if pkbDB.settingsDB.emotestokensDB[index] == locDB.ddDB.emotes[frnr][2] then
			match = true
			i = index
		end
	end
	if match == true then
		tremove(pkbDB.settingsDB.emotestokensDB, i)
		_G[ddchbtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Background-Dark")
		_G[ddchstr]:SetTextColor(1, 0.27, 0, 1)
	else
		tinsert(pkbDB.settingsDB.emotestokensDB, locDB.ddDB.emotes[frnr][2])
		_G[ddchstr]:SetTextColor(1, 0.8196079, 0, 1)
		_G[ddchbtn]:SetNormalTexture("Interface\\DialogFrame\\UI-DialogBox-Gold-Background")
	end

end

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

function PKBlow:PlayerLogin()

	PKBlow.eventHandler:UnregisterEvent("ADDON_LOADED")

	PKBlow:SortTable()
	PKBlow:CleanNmeTable()
	PKBlow:ClearTempNmeKills()
	PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
	PKBlow:GetRealms()
	PKBlow:KillCount()

	PKBlow:CreateLauncher()
	PKBlow:KillingBlowMessageFrame()
	PKBlow:MainGUI()
	PKBlow:CreateOptionsGUI()
--	PKBlow:CreateLastUpdateFrame()
	PKBlow:SetPopupDialogs()
	PKBlow:InitializeSlashHandler()
	PKBlow:HideMainFrame()
	PKBlow.eventHandler:UnregisterEvent("PLAYER_LOGIN")

end

-----------------------------------------------------------------------------------------------------------------
--------------------------[[  Slashcommands  ]]------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------

function PKBlow:InitializeSlashHandler()

	SlashCmdList.PKBlow = function()
		PKBlow_Frame:Show()
		if locDB.bool.splayer == true or locDB.bool.getrealm == true then
			PKBlow_Search:SetFocus()
		end
	end
	SLASH_PKBlow1 = "/pkb"
	SLASH_PKBlow2 = "/pkblow"

end

------------------------------------------------------------------------------------------------------------------
--------------------------[[  Hooked functions  ]]----------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------

local myhook = function(self)

	if GetUnitName("mouseover", true) ~= nil then
		local nmeplayer = GetUnitName("mouseover", true)
		local pattern = strfind(nmeplayer, "%p")
		if not pattern then
			nmeplayer = nmeplayer.."-"..locDB.misc.realmname
		end
		if (locDB.misc.lastmouseover ~= nmeplayer) then
			PKBlow:GameTTHandler(nmeplayer)
		end
	elseif GetUnitName("target", true) ~= nil then
		local nmeplayer = GetUnitName("target", true)
		local pattern = strfind(nmeplayer, "%p")
		if not pattern then
			nmeplayer = nmeplayer.."-"..locDB.misc.realmname
		end
		PKBlow:GameTTHandler(nmeplayer)
	end

end

GameTooltip:HookScript("OnTooltipSetUnit", myhook)
GameTooltip:HookScript("OnTooltipCleared", function()
	locDB.misc.lastmouseover = "" 					-- resets the mouseover target, prevents double printing on tooltip
end)

------------------------------------------------------------------------------------------------------------------
----------------------[[  Create frames for gui and messages  ]]--------------------------------------------------
------------------------------------------------------------------------------------------------------------------

function PKBlow:MakeMovable(frame)

	frame:SetMovable(true)
	frame:IsClampedToScreen(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)

end

function PKBlow:HideMainFrame()

	PKBlow_Frame:Hide()
	PKBlow_plclassList:Hide()
	PKBlow_plclassDdBg:Hide()

end

-- create a frame for the onscreen killing blow message
function PKBlow:KillingBlowMessageFrame()

	local fheight = 32
	local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB.Kb[1], pkbDB.settingsDB.fntflDB.Kb[2], pkbDB.settingsDB.fntflDB.Kb[3]
	local pkblowkbmsgfr = locDB.calls.api.createframe("MessageFrame", "PKBKbMessageFrame", UIParent)
	pkblowkbmsgfr:EnableMouse(false)
	pkblowkbmsgfr:SetPoint("CENTER", UIParent, pkbDB.settingsDB.guiDB.kbmsgfr.xpos, pkbDB.settingsDB.guiDB.kbmsgfr.ypos)
	pkblowkbmsgfr:SetWidth(322)
	pkblowkbmsgfr:SetHeight(48)
	pkblowkbmsgfr:SetTimeVisible(1)
	pkblowkbmsgfr:SetFading(1)
	PKBlow:SetFontWithFlags("PKBKbMessageFrame", "Kb", fheight)
	PKBlow:MakeMovable(PKBKbMessageFrame)

end

-- create main PKBlow window
function PKBlow:MainGUI()

	if pkbDB.settingsDB.guiDB.border ~= locDB.ddDB.border[1][1] then
		pkbDB.settingsDB.guiDB.edgesize = 12
	end

	-- backdrops for GUI
	local bg = {
		mainguibg = {
			bgFile = pkbDB.settingsDB.guiDB.mbg,
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		},
		childfrbg = {
			bgFile = pkbDB.settingsDB.guiDB.cbg,
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		},
		titlebg = {
			bgFile = nil,
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		},
		editboxbg = {
			bgFile = locDB.ddDB.bg[3][1],
			edgeFile = pkbDB.settingsDB.guiDB.border,
			tile = false,
			tileSize = 16,
			edgeSize = pkbDB.settingsDB.guiDB.edgesize,
			insets = {
				left = 3,
				right = 4,
				top = 4,
				bottom = 3
			}
		}
	}

	-- create main GUI
	local function SaveSetPoints(frame)

		local frame = frame
		pkbDB.settingsDB.guiDB.coords.xpos = floor(frame:GetLeft() + 0,5)
		pkbDB.settingsDB.guiDB.coords.ypos = floor(frame:GetBottom() + 0,5)

	end

	local w, h = 462, 486
	local xpos, ypos = pkbDB.settingsDB.guiDB.coords.xpos or (UIParent:GetWidth() / 2) - (w / 2), pkbDB.settingsDB.guiDB.coords.ypos or (UIParent:GetHeight() / 2)- (h / 2)
	local pkblowframe = locDB.calls.api.createframe("Frame", "PKBlow_Frame", UIParent)
	pkblowframe:EnableMouse(true)
	pkblowframe:RegisterForDrag("LeftButton")
	pkblowframe:EnableKeyboard(true)
	pkblowframe:SetClampedToScreen(true)
	pkblowframe:SetWidth(w)
	pkblowframe:SetHeight(h)
	pkblowframe:SetPoint("BOTTOMLEFT", xpos, ypos)
	pkblowframe:SetFrameStrata("HIGH")
	PKBlow_Frame:SetBackdrop(bg.mainguibg)
	tinsert(UISpecialFrames,PKBlow_Frame:GetName())
	PKBlow:MakeMovable(PKBlow_Frame)
	local closebutt = locDB.calls.api.createframe("Button", nil, PKBlow_Frame, "UIPanelCloseButton")
	closebutt:SetPoint("TOPRIGHT", 3, 2)
	pkblowframe:SetScript("OnMouseDown", function (self, button)
		if button == "LeftButton" then
			self:StartMoving()
		end
	end)
	pkblowframe:SetScript("OnMouseUp", function (self, button)
		if button == "LeftButton" then
			self:StopMovingOrSizing()
			SaveSetPoints(pkblowframe)
		end
	end)

	-- create titleframe
	local pkbtitleframe = locDB.calls.api.createframe("Frame", "PKBlow_TitleFrame", PKBlow_Frame)
	pkbtitleframe:SetWidth(462)
	pkbtitleframe:SetHeight(27)
	pkbtitleframe:SetPoint("TOP", PKBlow_Frame, "TOP", 0, 0)
	PKBlow_TitleFrame:SetBackdrop(bg.titlebg)
	local titlestring = PKBlow_TitleFrame:CreateFontString("PKBlow_TitleFrameString", "ARTWORK")
	titlestring:SetJustifyH("CENTER")
	titlestring:SetPoint("CENTER", PKBlow_TitleFrame, "CENTER", 0, -1)
	PKBlow:SetFontWithFlags("PKBlow_TitleFrameString", "GUI", 12)
	titlestring:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
	titlestring:SetText(addonname.."   v"..version)

	-- create headers for the messageframes
	local pkbnmeheader = locDB.calls.api.createframe("Frame", "PKBNmeHeader", PKBlow_Frame)
	pkbnmeheader:SetWidth(322)
	pkbnmeheader:SetHeight(30)
	pkbnmeheader:SetPoint("TOPLEFT", PKBlow_Frame, 5, -26)
	PKBNmeHeader:SetBackdrop(bg.childfrbg)
	pkbnmeheader:SetScript("OnEnter", function()
		local msg = "Ctrl-LeftClick player to copy armory URL"
		PKBlow:CreateTT(pkbnmeheader, "ANCHOR_TOP", 10, 0, msg)
	end)
	pkbnmeheader:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	local pkbnmeheaderfr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBNmeHeaderFr", PKBlow_Frame)
	local class = PKBlow:GetLocalizedClass()
	local msg = locDB.misc.currealm.." - "..strlower(class)
	pkbnmeheaderfr:SetWidth(322)
	pkbnmeheaderfr:SetHeight(30)
	pkbnmeheaderfr:SetPoint("TOPLEFT", PKBlow_Frame, 5, -17)
	PKBlow:SetFontWithFlags("PKBNmeHeaderFr", "GUI", 12)
	pkbnmeheaderfr:SetMaxLines(1)
	pkbnmeheaderfr:SetFading(false)
	pkbnmeheaderfr:SetJustifyH("CENTER")
	PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)

	local pkbtotkilledheader = locDB.calls.api.createframe("Button", "PKBTotalKilledHeader", PKBlow_Frame)
	pkbtotkilledheader:EnableMouse(true)
	pkbtotkilledheader:SetWidth(70)
	pkbtotkilledheader:SetHeight(30)
	pkbtotkilledheader:SetPoint("TOPRIGHT", PKBNmeHeader, 65, 0)
	PKBTotalKilledHeader:SetBackdrop(bg.childfrbg)
	pkbtotkilledheader:SetScript("OnClick", function()
		local list = "kills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(list)
	end)
	pkbtotkilledheader:SetScript("OnEnter", function()
		local msg = "Click to sort, click again to reset"
		PKBlow:CreateTT(pkbtotkilledheader, "ANCHOR_TOP",  10, 0, msg)
	end)
	pkbtotkilledheader:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local headerstring = PKBlow_TitleFrame:CreateFontString("PKBlow_TotKBHeaderStr", "ARTWORK")
	headerstring:SetJustifyH("CENTER")
	headerstring:SetPoint("CENTER", PKBTotalKilledHeader, "CENTER", 0, 0)
	PKBlow:SetFontWithFlags("PKBlow_TotKBHeaderStr", "GUI", 11)
	headerstring:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	headerstring:SetText(L["Tot KB's"])

	local pkbtempkilledheader = locDB.calls.api.createframe("Button", "PKBTempKilledHeader", PKBlow_Frame)
	pkbtempkilledheader:EnableMouse(true)
	pkbtempkilledheader:SetWidth(70)
	pkbtempkilledheader:SetHeight(30)
	pkbtempkilledheader:SetPoint("TOPRIGHT", PKBTotalKilledHeader, 65, 0)
	PKBTempKilledHeader:SetBackdrop(bg.childfrbg)
	pkbtempkilledheader:SetScript("OnClick", function()
		local list = "tmpkills"
		locDB.misc.list = list
		PKBlow:KillSortHandler(list)
	end)
	pkbtempkilledheader:SetScript("OnEnter", function()
		local msg = "Click to sort, click again to reset"
		PKBlow:CreateTT(pkbtempkilledheader, "ANCHOR_TOP",  10, 0, msg)
	end)
	pkbtempkilledheader:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local headerstring = PKBlow_TitleFrame:CreateFontString("PKBlow_CurKBHeaderStr", "ARTWORK")
	headerstring:SetJustifyH("CENTER")
	headerstring:SetPoint("CENTER", PKBTempKilledHeader, "CENTER", 0, 0)
	PKBlow:SetFontWithFlags("PKBlow_CurKBHeaderStr", "GUI", 11)
	headerstring:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
	headerstring:SetText(L["Cur KB's"])

	-- create messageframes backgrounds
	local pkbnmefrbg = locDB.calls.api.createframe("Frame", "PKBNmeFrameBg", PKBlow_Frame)
	pkbnmefrbg:SetWidth(322)
	pkbnmefrbg:SetHeight(316)
	pkbnmefrbg:SetPoint("BOTTOMLEFT", PKBNmeHeader, 0, -315)
	PKBNmeFrameBg:SetBackdrop(bg.childfrbg)

	local pkbtotkilledfrbg = locDB.calls.api.createframe("Frame", "PKBTotalKilledFrameBg", PKBlow_Frame)
	pkbtotkilledfrbg:SetWidth(70)
	pkbtotkilledfrbg:SetHeight(316)
	pkbtotkilledfrbg:SetPoint("TOPRIGHT", PKBNmeFrameBg, 65, 0)
	PKBTotalKilledFrameBg:SetBackdrop(bg.childfrbg)

	local pkbtmpkilledfrbg = locDB.calls.api.createframe("Frame", "PKBTempKilledFrameBg", PKBlow_Frame)
	pkbtmpkilledfrbg:SetWidth(70)
	pkbtmpkilledfrbg:SetHeight(316)
	pkbtmpkilledfrbg:SetPoint("TOPRIGHT", PKBTotalKilledFrameBg, 65, 0)
	PKBTempKilledFrameBg:SetBackdrop(bg.childfrbg)

	local function nmelist(name, h, w, xpos, ypos)

		local index = 1
		local xpos, ypos = xpos, ypos
		local h, w = h, w
		while index <= locDB.const.MAXLINES do
			local frname = "PKBlow"..name
			local nmefr = locDB.calls.api.createframe("Button", frname, PKBNmeFrameBg, nil, index)
			nmefr:EnableMouse(true)
			nmefr:SetID(index)
			nmefr:SetWidth(w)
			nmefr:SetHeight(h)
			nmefr:SetPoint("TOPLEFT", PKBNmeFrameBg, xpos, ypos)
			nmefr:SetHighlightTexture(locDB.ddDB.bg[5][1])
			nmefr:SetScript("OnClick", function(self, button, down)
				local ctrldown  = IsControlKeyDown()
				if ctrldown then
					local index = nmefr:GetID()
					PKBlow:CopyNme(frname, index)
				end
			end)
			ypos = ypos - 12
			index = index + 1
		end

	end

	local h, w, xpos, ypos = 14, 446, 3, -7
	nmelist("NmeButtonList", h, w, xpos, ypos)

	-- create messageframes
	local pkbnmefr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBNmeFrame", PKBlow_Frame)
	pkbnmefr:SetWidth(322)
	pkbnmefr:SetHeight(322)
	pkbnmefr:SetPoint("BOTTOMLEFT", PKBNmeHeader, 0, -307)
	PKBlow:SetFontWithFlags("PKBNmeFrame", "GUI", 12)
	pkbnmefr:SetMaxLines(locDB.const.MAXLINES)
	pkbnmefr:SetFading(false)
	pkbnmefr:SetJustifyH("LEFT")

	local pkbtotkilledfr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBTotalKilledFrame", PKBlow_Frame)
	pkbtotkilledfr:SetWidth(70)
	pkbtotkilledfr:SetHeight(322)
	pkbtotkilledfr:SetPoint("TOPRIGHT", PKBNmeFrame, 65, 0)
	PKBlow:SetFontWithFlags("PKBTotalKilledFrame", "GUI", 12)
	pkbtotkilledfr:SetMaxLines(locDB.const.MAXLINES)
	pkbtotkilledfr:SetFading(false)
	pkbtotkilledfr:SetJustifyH("CENTER")

	local pkbtempkilledfr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBTempKilledFrame", PKBlow_Frame)
	pkbtempkilledfr:SetWidth(70)
	pkbtempkilledfr:SetHeight(322)
	pkbtempkilledfr:SetPoint("TOPRIGHT", PKBTotalKilledFrame, 65, 0)
	PKBlow:SetFontWithFlags("PKBTempKilledFrame", "GUI", 12)
	pkbtempkilledfr:SetMaxLines(locDB.const.MAXLINES)
	pkbtempkilledfr:SetFading(false)
	pkbtempkilledfr:SetJustifyH("CENTER")

	-- create a dropdrown to select class to show
	PKBlow:CreateDDHeaderFrame("plclass", SHOW.." "..strlower(CLASS), "PKBNmeFrame", 185, 25, 267, -411)
	PKBlow:CreateDDFrame("plclass", "PKBlow_Frame", #locDB.ddDB.plclass, 185, 18, -29)
	PKBlow:CreateDDChild("plclass", "plclass", #locDB.ddDB.plclass, 177, 18, -28)
	PKBlow:InitializeDD("plclass", "plcl", "plclass", nil, nil)
	PKBlow:OnClickDD("plclass",#locDB.ddDB.plclass, "plcl", "plclass", nil, nil)

	local pkbbuttonsbg = locDB.calls.api.createframe("Frame", "PKBlow_ButtonsBg", PKBlow_Frame)
	pkbbuttonsbg:SetWidth(260)
	pkbbuttonsbg:SetHeight(75)
	pkbbuttonsbg:SetPoint("BOTTOMLEFT", PKBNmeFrame, 0, -85)
	PKBlow_ButtonsBg:SetBackdrop(bg.childfrbg)

	-- create button to search for specific player (on all realms or specific realm)
	local searchplbtn = locDB.calls.api.createframe("Button", "PKBlow_SearchPlButton", PKBlow_Frame, "UIPanelButtonTemplate")
	searchplbtn:SetWidth(130)
	searchplbtn:SetHeight(30)
	searchplbtn:SetPoint("BOTTOMLEFT", PKBNmeFrame, 2, -78)
	searchplbtn:SetText(L["Search"].." "..strlower(PLAYER))
	searchplbtn:SetFrameStrata("TOOLTIP")
	searchplbtn:SetScript("OnClick", function()
		local nmeindex = 0
		local pagenr = 1
		local msg = ""
		local realm = locDB.misc.currealm
		local tableid = locDB.tbl.id
		PKBlow_Search:SetText(msg)
		PKBlow_Search:SetFocus()
		if locDB.bool.realmset == true or locDB.bool.getrealm == true then
			tableid = locDB.tbl.ctbl[locDB.const.nme]
			locDB.tbl.id = tableid
			PKBlow:ClassSelect(locDB.ddDB.plcl)
			tableid = locDB.tbl.ctbl[locDB.const.rlm]
			locDB.tbl.id = tableid
		end
		if locDB.bool.class == true then
			PKBlow:ClassSelect(locDB.ddDB.plcl)
		end
		PKBlow:ClearFrames()
		locDB.bool.splayer = true
		local class = PKBlow:GetLocalizedClass()
		if locDB.bool.getrealm == true and locDB.misc.currealm ~= L["All realms"] then
			realm = realm.."..."
		end
		msg = realm.." - "..strlower(class)
		PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
		PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		locDB.bool.ksorted = false
		locDB.bool.tksorted = false
	end)

	local function PKBRealmButtonsOnClick(msg)

		local msg = msg
		local nmeindex = 0
		local pagenr = 1
		local tableid = locDB.tbl.ctbl[locDB.const.nme]
		locDB.tbl.id = tableid
		PKBlow_Search:SetText(msg)
		if locDB.bool.getrealm == true then
			PKBlow_Search:SetFocus()
		else
			PKBlow_Search:ClearFocus()
		end
		locDB.misc.currealm = L["All realms"]
		msg = locDB.misc.currealm
		if locDB.bool.class == true then
 			PKBlow:ClassSelect(locDB.ddDB.plcl)
		else
			PKBlow:SetCurrentTables(PKBlowDB, locDB.kills.tmpkilltable)
			PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
		end
		local class = PKBlow:GetLocalizedClass()
		msg = msg.." - "..strlower(class)
		PKBNmeHeaderFr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		locDB.bool.ksorted = false
		locDB.bool.tksorted = false

	end

	-- create button to list players from a specific realm
	local searchrealmbtn = locDB.calls.api.createframe("Button", "PKBlow_SearchRealmButton", PKBlow_Frame, "UIPanelButtonTemplate")
	searchrealmbtn:SetWidth(130)
	searchrealmbtn:SetHeight(30)
	searchrealmbtn:SetPoint("BOTTOMLEFT", PKBNmeFrame, 2, -46)
	searchrealmbtn:SetText(L["Get realm"])
	searchrealmbtn:SetFrameStrata("TOOLTIP")
	searchrealmbtn:SetScript("OnClick", function()
		local msg = ""
		locDB.bool.realmset = false
		locDB.bool.getrealm = true
		locDB.bool.splayer = false
		PKBRealmButtonsOnClick(msg)
	end)

	-- reset currenttables to all realms
	local allrealmsbtn = locDB.calls.api.createframe("Button", "PKBlow_AllRealmsButton", PKBlow_Frame, "UIPanelButtonTemplate")
	allrealmsbtn:SetWidth(130)
	allrealmsbtn:SetHeight(30)
	allrealmsbtn:SetPoint("BOTTOMLEFT", PKBNmeFrame, 128, -46)
	allrealmsbtn:SetText(L["All realms"])
	allrealmsbtn:SetFrameStrata("TOOLTIP")
	allrealmsbtn:SetScript("OnClick", function()
		local msg = locDB.fcolor.darkgrey..L["Search"].."|r"
		locDB.bool.realmset = false
		locDB.bool.getrealm = false
		locDB.bool.splayer = false
		PKBRealmButtonsOnClick(msg)
	end)

	-- create button to go directly to optionspanel
	local optionsbtn = locDB.calls.api.createframe("Button", "PKBlow_OptionsButton", PKBlow_Frame, "UIPanelButtonTemplate")
	optionsbtn:SetWidth(130)
	optionsbtn:SetHeight(30)
	optionsbtn:SetPoint("BOTTOMLEFT", PKBNmeFrame, 128, -78)
	optionsbtn:SetText(OPTIONS_MENU)
	optionsbtn:SetFrameStrata("TOOLTIP")
	optionsbtn:SetScript("OnClick", function()
		PKBlow:HideMainFrame()
		InterfaceOptionsFrame_OpenToCategory(PKBlow_Panel)
	end)

	-- create background for editbox (SetBackdrop doesn't work properly for editbox)
	local pkbsearchbg = locDB.calls.api.createframe("Frame", "PKBlow_SearchBg", PKBlow_Frame)
	pkbsearchbg:SetWidth(260)
	pkbsearchbg:SetHeight(24)
	pkbsearchbg:SetPoint("BOTTOMLEFT", PKBNmeFrame, 0, -114)
	PKBlow_SearchBg:SetBackdrop(bg.editboxbg)
	pkbsearchbg:EnableMouse(false)

	local function PKBSearchBoxOnTextChanged()

		if locDB.bool.realmset == true then
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.rlm]
		else
			locDB.tbl.id = locDB.tbl.ctbl[locDB.const.nme]
		end
		if locDB.bool.class == true then
			PKBlow:ClassSelect(locDB.ddDB.plcl)
		end
		if locDB.bool.splayer == true then
			PKBlow:SetPlayer()
		elseif locDB.bool.realmset == false and locDB.bool.getrealm == true then
			PKBlow:SetRealm()
		end
		if locDB.bool.ksorted == true then
			locDB.bool.ksorted = false
			local list = "kills"
			locDB.misc.list = list
			PKBlow:KillSortHandler(locDB.misc.list)
		elseif locDB.bool.tksorted == true then
			locDB.bool.tksorted = false
			local list = "tmpkills"
			locDB.misc.list = list
			PKBlow:KillSortHandler(locDB.misc.list)
		end

	end

	-- create editbox for searching tables
	local pkbsearch = locDB.calls.api.createframe("EditBox", "PKBlow_Search", PKBlow_Frame, "InputBoxTemplate")
	local searchmsg = locDB.fcolor.darkgrey..L["Search"].."|r"
	pkbsearch:SetWidth(252)
	pkbsearch:SetHeight(24)
	pkbsearch:SetTextInsets(3,0,0,0)
	pkbsearch:EnableMouse(false)
	pkbsearch:SetText(searchmsg)
	pkbsearch:SetPoint("BOTTOMLEFT", PKBNmeFrame, 6, -114)
	pkbsearch:SetAutoFocus(false)
	pkbsearch:SetScript("OnTextChanged", function()
		PKBSearchBoxOnTextChanged()
	end)

	-- create pagesframe, to scroll trough pages
 	local pkbpagesbg = locDB.calls.api.createframe("Frame", "PKBlow_PagesBg", PKBlow_Frame)
	pkbpagesbg:SetWidth(185)
 	pkbpagesbg:SetHeight(30)
	pkbpagesbg:SetPoint("BOTTOMRIGHT", PKBNmeFrame, 130, -40)
	PKBlow_PagesBg:SetBackdrop(bg.childfrbg)

	local pkbpagesfr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBPagesFrame", PKBlow_Frame)
	pkbpagesfr:SetWidth(185)
	pkbpagesfr:SetHeight(30)
	pkbpagesfr:SetPoint("BOTTOMRIGHT", PKBNmeFrame, 130, -31)
	PKBlow:SetFontWithFlags("PKBPagesFrame", "GUI", 12)
	pkbpagesfr:SetMaxLines(1)
	pkbpagesfr:SetFading(false)
	pkbpagesfr:SetJustifyH("CENTER")
	local pagenr, pages, _ = PKBlow:Pages(PKBlowDB)
	local msg = pagenr.."/"..pages
	pkbpagesfr:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)

	local bckbutton = locDB.calls.api.createframe("Button", "PKBBackButton", PKBPagesFrame, "UIPanelButtonTemplate")
	bckbutton:SetWidth(20)
	bckbutton:SetHeight(20)
	bckbutton:SetPoint("LEFT", PKBlow_PagesBg, 35, 0)
	bckbutton:SetText("<")
	bckbutton:SetScript("OnClick", function()
		local tableid = locDB.tbl.id
		local nmeindex = 0
		local pagenr, pages, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
		if (pagenr <= pages) and (pagenr ~= 1) then
			pagenr = pagenr - 1
			nmeindex = (pagenr * locDB.const.MAXLINES) - locDB.const.MAXLINES
			locDB.misc.page = pagenr
			local msg = pagenr.."/"..pages
			PKBPagesFrame:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
			PKBlow:PageBack(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
		end
	end)

	-- go to page 1
	local fstbckbutton = locDB.calls.api.createframe("Button", "PKBFastBackButton", PKBPagesFrame, "UIPanelButtonTemplate")
	fstbckbutton:SetWidth(20)
	fstbckbutton:SetHeight(20)
	fstbckbutton:SetPoint("LEFT", PKBlow_PagesBg, 10, 0)
	fstbckbutton:SetText("<<")
	fstbckbutton:SetScript("OnClick", function()
		local tableid = locDB.tbl.id
		local nmeindex = 0
		local pagenr = 1
		local _, pages, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
		local msg = pagenr.."/"..pages
		locDB.misc.page = pagenr
		PKBPagesFrame:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		PKBlow:PageBack(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
	end)

	local nxtbutton = locDB.calls.api.createframe("Button", "PKBNextButton", PKBPagesFrame, "UIPanelButtonTemplate")
	nxtbutton:SetWidth(20)
	nxtbutton:SetHeight(20)
	nxtbutton:SetPoint("Right", PKBlow_PagesBg, -35, 0)
	nxtbutton:SetText(">")
	nxtbutton:SetScript("OnClick", function()
		local tableid = locDB.tbl.id
		local nmeindex = 0
		local pagenr, pages, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
		if pagenr ~= pages then
			nmeindex = pagenr * locDB.const.MAXLINES
			if nmeindex ~= 0 then
				pagenr = pagenr + 1
				local msg = pagenr.."/"..pages
				PKBPagesFrame:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
				PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
			end
		end
	end)

	-- go to last page
	local fstnxtbutton = locDB.calls.api.createframe("Button", "PKBFastNextButton", PKBPagesFrame, "UIPanelButtonTemplate")
	fstnxtbutton:SetWidth(20)
	fstnxtbutton:SetHeight(20)
	fstnxtbutton:SetPoint("Right", PKBlow_PagesBg, -10, 0)
	fstnxtbutton:SetText(">>")
	fstnxtbutton:SetScript("OnClick", function()
		local tableid = locDB.tbl.id
		local nmeindex = 0
		local msg = ""
		local _, pages, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
		local pagenr = pages
		nmeindex = (pagenr - 1) * locDB.const.MAXLINES
		msg = pagenr.."/"..pages
		PKBPagesFrame:AddMessage(msg, locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)
	end)

	-- create frame to show all kills and total kills since last login
 	local pkbkillsbg = locDB.calls.api.createframe("Frame", "PKBlow_KillsBg", PKBlow_Frame)
	pkbkillsbg:SetWidth(185)
 	pkbkillsbg:SetHeight(40)
	pkbkillsbg:SetPoint("BOTTOMRIGHT", PKBNmeFrame, 130, -85)
	PKBlow_KillsBg:SetBackdrop(bg.childfrbg)
	local pkbkillsfr = locDB.calls.api.createframe("ScrollingMessageFrame", "PKBKillsFrame", PKBlow_Frame)
	pkbkillsfr:SetWidth(185)
	pkbkillsfr:SetHeight(40)
	pkbkillsfr:SetPoint("BOTTOMRIGHT", PKBNmeFrame, 130, -76)
	PKBlow:SetFontWithFlags("PKBKillsFrame", "GUI", 12)
	pkbkillsfr:SetMaxLines(2)
	pkbkillsfr:SetFading(false)
	pkbkillsfr:SetJustifyH("CENTER")
	PKBlow:TotalKillMsg()

	local tableid = PKBlow:GetTableID()
	local nmeindex = PKBlow:GetNmeIndex(locDB.tbl[tableid].nme)
	local pagenr, _, _ = PKBlow:Pages(locDB.tbl[tableid].nme)
	PKBlow:NextPage(nmeindex, pagenr, locDB.tbl[tableid].nme, locDB.tbl[tableid].kills, locDB.tbl[tableid].tmpkills, locDB.tbl[tableid].class)

end

function PKBlow:CreateLastUpdateFrame()

	local bg = {
		bgFile = "Interface\\TutorialFrame\\TutorialFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,
		tileSize = 8,
		edgeSize = 16,
		insets = {
			left = 3,
			right = 4,
			top = 4,
			bottom = 3,
		}
	}
	local updFrame = CreateFrame("Frame", "PKBlowLastUpdateFrame", UIParent)
	updFrame:SetSize(540, 240)
	updFrame:SetBackdrop(bg)
	updFrame:SetPoint("CENTER", 0, -20)
	local closeButton = CreateFrame("Button", nil, updFrame, "UIPanelCloseButton")
	closeButton:SetPoint("TOPRIGHT", 3, 2)
	local helpText = updFrame:CreateFontString("CEBHelpText", "OVERLAY")
	helpText:SetPoint("TOPLEFT", 15, -15)
	helpText:SetFont("Fonts\\ARIALN.TTF", 14)
	helpText:SetJustifyH("LEFT")
--~ 	local txtDB = locDB.helpText
	local msg = "Last update, working on a total revision, coming soon: PKBlow2"
	helpText:SetText(msg)
	local chkBox = CreateFrame("CheckButton", "LastUpdateFrameCheckButton", updFrame, "ChatConfigCheckButtonTemplate")
	chkBox:SetPoint("BOTTOMLEFT", updFrame, 15, 10)
	local chkBoxTxt = "LastUpdateFrameCheckButton".."Text"
	local txt = " Don't show this message again"
	_G[chkBoxTxt]:SetFont("Fonts\\ARIALN.TTF", 14)
	_G[chkBoxTxt]:SetText(txt)
	if PKBlowDB.noHelpText then
		chkBox:SetChecked(true)
	else
		chkBox:SetChecked(false)
	end
	chkBox:SetScript("OnClick", function()
		local ischecked = chkBox:GetChecked()
		if ischecked == 1 then
			PKBlow.noHelpText = true
		else
			PKBlow.noHelpText = false
		end
	end)
	updFrame:Show()

end

-----------------------------------------------------------------------------------------------------------------
-------------------------[[ create the Interface Addon Options GUI ]]---------------------------------------------
-----------------------------------------------------------------------------------------------------------------

function PKBlow:CreateOptionsGUI()

	local function PKBlow_Panel_Close()

		PKBlow_GUIList:Hide()
		PKBlow_GUIDdBg:Hide()
		PKBlow_KbList:Hide()
		PKBlow_KbDdBg:Hide()
		PKBlow_chatchanList:Hide()
		PKBlow_chatchanDdBg:Hide()
		PKBlow_mbgList:Hide()
		PKBlow_mbgDdBg:Hide()
		PKBlow_cbgList:Hide()
		PKBlow_cbgDdBg:Hide()
		PKBlow_borderList:Hide()
		PKBlow_borderDdBg:Hide()
		PKBlow_fntflagList:Hide()
		PKBlow_fntflagDdBg:Hide()
		PKBlow_fntflagkbList:Hide()
		PKBlow_fntflagkbDdBg:Hide()
		local frcount = floor(#locDB.ddDB.emotes / locDB.maxentries) + 1
		for i = 1, frcount do
			_G["PKBlow_emo"..i.."List"]:Hide()
			_G["PKBlow_emo"..i.."DdBg"]:Hide()
			_G["PKBlow_emo"..i.."TitleFrame"]:Show()
		end

	end

	local function PKBlow_CreateOptionBackgrounds(frname, parent, width, height, xpos, ypos, bool)

		local frname, parent = frname, parent
		local bool = bool
		local optbg = locDB.calls.api.createframe("Frame", frname, _G[parent])
		local bg = {
				bgFile = locDB.ddDB.bg[1][1],
				edgeFile = locDB.ddDB.border[1][1],
				tile = false,
				tileSize = 16,
				edgeSize = 16,
				insets = {
					left = 0,
					right = 0,
					top = 0,
					bottom = 0
				}
			}
		if bool == true then
			bg = {
				bgFile = locDB.ddDB.bg[7][1],
				edgeFile = locDB.ddDB.border[1][1],
				tile = false,
				tileSize = 16,
				edgeSize = 16,
				insets = {
					left = 3,
					right = 4,
					top = 4,
					bottom = 3
				}
			}
		end
		optbg:SetWidth(width)
		optbg:SetHeight(height)
		optbg:SetBackdrop(bg)
		optbg:SetPoint("TOPLEFT", xpos, ypos)

	end

	local function PKBlow_CreateOptionHeaders(panel, name, title)

		local  panel, name, title = panel, name, title
		local frname = "PKBlow_"..name.."Bg"
		local optbg = PKBlow_CreateOptionBackgrounds(frname, panel, 420, 60, 20, -10, true)
		local optpanel = _G[frname]:CreateFontString(nil, "ARTWORK", "GameFontRedLarge")
		local opticon = _G[frname]:CreateTexture("PKBlowIcon", "ARTWORK", UIParent)
		local opttitle = _G[frname]:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		opticon:SetTexture("interface\\pvprankbadges\\pvprank14")
		opticon:SetPoint("TOPLEFT", 20, -11)
		optpanel:SetPoint("TOPLEFT", 60, -16)
		local font = "Interface\\AddOns\\PKBlow\\Fonts\\Kornik.ttf"
		local msgfont = optpanel:SetFont(font, 32, "OUTLINE")
		optpanel:SetTextColor(locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
		optpanel:SetText(" "..addonname.." v".. version)
		optpanel:SetPoint("CENTER", 0, -65)
		local msgfont = opttitle:SetFont(font, 24, "OUTLINE")
		opttitle:SetTextColor(locDB.fcolor.blzzyellow.r, locDB.fcolor.blzzyellow.g, locDB.fcolor.blzzyellow.b, 1)
		opttitle:SetText(title)
		opttitle:SetPoint("CENTER", 0, -57)

	end

	local function SetCheckBox(frname, frame)

		local frname = frname
		if frname == "showlauncher" then
			if pkbDB.optDB[frname] == 1 then
				pkbDB.ldbDB.minimapicon.hide = false
				PKBIcon:Show("PKBlow")
				_G[frame]:SetChecked(false)
			else
				pkbDB.ldbDB.minimapicon.hide = true
				PKBIcon:Hide("PKBlow")
				_G[frame]:SetChecked(true)
			end
		else
			if pkbDB.optDB[frname] == 1 then
				_G[frame]:SetChecked(true)
			else
				_G[frame]:SetChecked(false)
			end
		end

	end

	local function CreateOptionPanelCheckBox(frname, parent, text, xpos, ypos)

		local frname = frname
		local parent = parent
		local text = text
		local xpos, ypos = xpos, ypos
		local fheight = 12
		local fntfl1, fntfl2, fntfl3 = pkbDB.settingsDB.fntflDB.GUI[1], pkbDB.settingsDB.fntflDB.GUI[2], pkbDB.settingsDB.fntflDB.GUI[3]
		local frame = "PKBlow_"..frname.."CheckButton"
		local chkbx = locDB.calls.api.createframe("CheckButton", frame, _G[parent], "ChatConfigCheckButtonTemplate")
		local chkbxtxt = frame.."Text"
		chkbx:SetPoint("TOPLEFT", _G[parent], xpos, ypos)
		PKBlow:SetFontWithFlags(chkbxtxt, "GUI", fheight)
		_G[chkbxtxt]:SetText(L[text])
		SetCheckBox(frname, frame)
		chkbx:SetScript("OnClick", function()
			local ischecked = _G[frame]:GetChecked()
			if frname == "showlauncher" then
				if ischecked == 1 then
					pkbDB.ldbDB.minimapicon.hide = true
					pkbDB.optDB[frname] = 0
					PKBIcon:Hide("PKBlow")
				else
					pkbDB.ldbDB.minimapicon.hide = false
					pkbDB.optDB[frname] = 1
					PKBIcon:Show("PKBlow")
				end
			elseif frname == "custchat" then
				if ischecked == 1 then
					pkbDB.optDB[frname] = 1
					if pkbDB.custchat == "" then
						StaticPopup_Show("PKBCUSTCHATMSG_BUTTON")
					end
				else
					pkbDB.optDB[frname] = 0
				end
			else
				if ischecked == 1 then
					pkbDB.optDB[frname] = 1
				else
					pkbDB.optDB[frname] = 0
				end
			end
		end)

	end

	local PKBpanel = locDB.calls.api.createframe("Frame", "PKBlow_Panel", UIParent)
	PKBpanel:Hide()
	PKBpanel.name = addonname
	PKBpanel.okay = function (self) PKBlow_Panel_Close() end
	PKBpanel.cancel = function (self) PKBlow_Panel_Close() end
	PKBpanel:SetScript("OnHide", function()
		PKBlow_Panel_Close()
	end)

	local uipanel = locDB.calls.api.createframe("Frame", "PKBlow_Panel_UI", PKBpanel)
	uipanel:Hide()
	uipanel.name = "Display"
	uipanel.parent = PKBpanel.name
	uipanel.okay = function (self) PKBlow_Panel_Close() end
	uipanel.cancel = function (self) PKBlow_Panel_Close() end
	uipanel:SetScript("OnHide", function()
		PKBlow_Panel_Close()
	end)

	local kbchatpanel = locDB.calls.api.createframe("Frame", "PKBlow_Panel_KbChat", PKBpanel)
	kbchatpanel:Hide()
	kbchatpanel.name = "Chat"
	kbchatpanel.parent = PKBpanel.name
	kbchatpanel.okay = function (self) PKBlow_Panel_Close() end
	kbchatpanel.cancel = function (self) PKBlow_Panel_Close() end
	kbchatpanel:SetScript("OnHide", function()
		PKBlow_Panel_Close()
	end)

	local emotepanel = locDB.calls.api.createframe("Frame", "PKBlow_Panel_Emotes", PKBpanel)
	emotepanel:Hide()
	emotepanel.name = EMOTE
	emotepanel.parent = PKBpanel.name
	emotepanel.okay = function (self) PKBlow_Panel_Close() end
	emotepanel.cancel = function (self) PKBlow_Panel_Close() end
	emotepanel:SetScript("OnHide", function()
		PKBlow_Panel_Close()
	end)

	local kbannouncepanel = locDB.calls.api.createframe("Frame", "PKBlow_Panel_KbAnnounce", PKBpanel)
	kbannouncepanel:Hide()
	kbannouncepanel.name = "Announce"
	kbannouncepanel.parent = PKBpanel.name
	kbannouncepanel.okay = function (self) PKBlow_Panel_Close() end
	kbannouncepanel.cancel = function (self) PKBlow_Panel_Close() end
	kbannouncepanel:SetScript("OnHide", function()
		PKBlow_Panel_Close()
	end)

	PKBlow_CreateOptionHeaders("PKBlow_Panel", "GenOptTitle", "General")
	PKBlow_CreateOptionHeaders("PKBlow_Panel_UI", "DispOptTitle", "Display")
	PKBlow_CreateOptionHeaders("PKBlow_Panel_KbAnnounce", "KbAOptTitle", "Announce")
	PKBlow_CreateOptionHeaders("PKBlow_Panel_Emotes", "EmOptTitle", "Emotes")
	PKBlow_CreateOptionHeaders("PKBlow_Panel_KbChat", "KbChatOptTitle", "Chat")

	PKBlow_CreateOptionBackgrounds("GenOpt", "PKBlow_Panel", 420, 355, 20, -95, false)
	PKBlow_CreateOptionBackgrounds("DispOpt", "PKBlow_Panel_UI", 420, 420, 20, -95, false)
	PKBlow_CreateOptionBackgrounds("ChatOpt", "PKBlow_Panel_KbChat", 420, 300, 20, -95, false)
	PKBlow_CreateOptionBackgrounds("KbAOpt", "PKBlow_Panel_KbAnnounce", 420, 340, 20, -95, false)
	PKBlow_CreateOptionBackgrounds("EmoOpt", "PKBlow_Panel_Emotes", 500, 380, 20, -95, false)

	PKBlow:CreateDDHeaderFrame("mbg", "Main window bg", "PKBlow_Panel_UI", 182, 25, 40, -200)
	PKBlow:CreateDDHeaderFrame("cbg", "Child window bg", "PKBlow_Panel_UI", 182, 25, 230, -200)
	PKBlow:CreateDDHeaderFrame("border", "Border", "PKBlow_Panel_UI", 182, 25, 40, -280)
	PKBlow:CreateDDHeaderFrame("GUI", "General font", "PKBlow_Panel_UI", 182, 25, 40, -360)
	PKBlow:CreateDDHeaderFrame("fntflag", "Outline", "PKBlow_Panel_UI", 182, 25, 230, -360)
	PKBlow:CreateDDHeaderFrame("Kb", "Kb announce font", "PKBlow_Panel_KbAnnounce", 182, 25, 40, -200)
	PKBlow:CreateDDHeaderFrame("fntflagkb", "Kb announce outline", "PKBlow_Panel_KbAnnounce", 182, 25, 230, -200)
	PKBlow:CreateDDHeaderFrame("chatchan", "Chat channels", "PKBlow_Panel_KbChat", 182, 25, 40, -200)

	PKBlow:CreateDDFrame("chatchan", "PKBlow_Panel_KbChat", #locDB.ddDB.chatchan, 178, 18, -29)
	PKBlow:CreateDDFrame("border", "PKBlow_Panel_UI", #locDB.ddDB.border, 182,  18, - 28)
	PKBlow:CreateDDFrame("fntflag", "PKBlow_Panel_UI", #locDB.ddDB.fntflag, 182, 18, -28)
	PKBlow:CreateDDFrame("fntflagkb", "PKBlow_Panel_KbAnnounce", #locDB.ddDB.fntflag, 182, 18, -28)

	PKBlow:CreateDDChild("chatchan", "chatchan", #locDB.ddDB.chatchan, 170, 18, -28)
	PKBlow:CreateDDChild("border", "border", #locDB.ddDB.border, 174, 18, -26)
	PKBlow:CreateDDChild("fntflag", "fntflag", #locDB.ddDB.fntflag, 174, 18, -26)
	PKBlow:CreateDDChild("fntflagkb", "fntflag", #locDB.ddDB.fntflag, 174, 18, -26)

	PKBlow:InitializeDD("chatchan", "chatDB", "chatchan", nil, "true")
	PKBlow:InitializeDD("border", "guiDB", "border", nil, "true")
	PKBlow:InitializeDD("fntflag", "fntflDB", "fntflag", "GUI", "true")
	PKBlow:InitializeDD("fntflagkb", "fntflDB", "fntflag", "Kb", "true")

	PKBlow:OnClickDD("chatchan", 7, "chatDB", "chatchan", nil, "true")
	PKBlow:OnClickDD("border", 3, "guiDB", "border", nil, "true")
	PKBlow:OnClickDD("fntflag", 3, "fntflDB", "fntflag", "GUI", "true")
	PKBlow:OnClickDD("fntflagkb", 3, "fntflDB", "fntflag", "Kb", "true")

	PKBlow:CreateScrollFrame("GUI", PKBlow_Panel_UI, 10, "fontsDB", "fonts", 154,  18, - 28)
 	PKBlow:CreateScrollFrame("Kb", PKBlow_Panel_KbAnnounce, 10,  "fontsDB", "fonts", 154,  18, - 28)
	PKBlow:CreateScrollFrame("mbg", PKBlow_Panel_UI, 10, "guiDB", "bg", 154,  18, - 28)
	PKBlow:CreateScrollFrame("cbg", PKBlow_Panel_UI, 10, "guiDB", "bg", 154,  18, - 28)

	PKBlow:CreateScrollableDDChild("GUI", 10, "fontsDB", "fonts", 125, 18, -26)
	PKBlow:CreateScrollableDDChild("Kb", 10, "fontsDB", "fonts", 125, 18, -26)
	PKBlow:CreateScrollableDDChild("mbg", 10, "guiDB", "bg", 125, 18, -26)
	PKBlow:CreateScrollableDDChild("cbg", 10, "guiDB", "bg", 125, 18, -26)

	PKBlow:CreateShowChangeFrame("mbg", "PKBlow_Panel_UI", "mbg", " "..addonname.." v".. version, "orangered", nil, 374, 75, 40, -115)
	PKBlow:CreateShowChangeFrame("cbg", "PKBlow_mbgBgChangeFrame", "cbg", "All classes - all realms", "blzzyellow", nil,  334, 30, 22, -30)
	PKBlow:CreateDemoKillingBlowMessageFrame()

	CreateOptionPanelCheckBox("showlauncher", "PKBlow_Panel", " Hide minimapbutton", 40, -120)
	CreateOptionPanelCheckBox("showgamett", "PKBlow_Panel", " Show kills in tooltip", 40, -155)
	CreateOptionPanelCheckBox("showpkbtt",  "PKBlow_Panel", " Show PKBlow tooltips", 40, -190)
	CreateOptionPanelCheckBox("kbannounce", "PKBlow_Panel", " Killing blow announcer", 40, -225)
	CreateOptionPanelCheckBox("scrshot",  "PKBlow_Panel", " Screenshot", 40, -260)
	CreateOptionPanelCheckBox("showchatmsg", "PKBlow_Panel", " Announce KB in chat", 40, -295)
	CreateOptionPanelCheckBox("playsounds", "PKBlow_Panel", " Play kill sounds", 40, -330)
	CreateOptionPanelCheckBox("doemote", "PKBlow_Panel", " Use emotes", 40, -365)
	CreateOptionPanelCheckBox("kstreakreset", "PKBlow_Panel", " Reset killstreak", 40, -400)
	CreateOptionPanelCheckBox("custchat", "PKBlow_Panel_KbChat", " Use custom chat message", 40, -125)

	local frcount = floor(#locDB.ddDB.emotes / locDB.maxentries) + 1
	local xpos, ypos = 40, -205
	local rows = 1
	for j = 1, frcount do
		PKBlow:CreateEmoDDHeaderFrame("emo"..j, "emotes", "PKBlow_Panel_Emotes", 142, 25, xpos, ypos)
		PKBlow:CreateEmoDDFrame("emo"..j, j, "PKBlow_Panel_Emotes", 142, locDB.height, -29)
		PKBlow:CreateEmoDDChild("emo"..j, j, 134, locDB.height, -28)
		PKBlow:InitializeEmoDD("emo"..j, j)
		PKBlow:OnClickEmoDD("emo"..j, j)
		if rows == locDB.maxrows then
			rows = 0
			xpos = -110
			ypos = ypos - 60
		end
		rows = rows + 1
		xpos = xpos + 150
	end

	local defaultbutton = locDB.calls.api.createframe("Button", "PKBOptionsDefaultButton", PKBpanel, "UIPanelButtonTemplate")
	defaultbutton:SetWidth(125)
	defaultbutton:SetHeight(30)
	defaultbutton:SetPoint("TOPLEFT", PKBpanel, 280, -155)
	defaultbutton:SetText(locDB.calls.globstr.default)
	defaultbutton:SetScript("OnClick", function()
		PKBlow:SetDefault()
	end)
	defaultbutton:SetScript("OnEnter", function()
		local msg = "Click to set to default values"
		PKBlow:CreateTT(defaultbutton, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	defaultbutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local wipebutton = locDB.calls.api.createframe("Button", "PKBOptionsWipeButton", PKBpanel, "UIPanelButtonTemplate")
	wipebutton:SetWidth(125)
	wipebutton:SetHeight(30)
	wipebutton:SetPoint("TOPLEFT", PKBpanel, 280, -255)
	wipebutton:SetText(CLEAR_ALL)
	wipebutton:SetScript("OnClick", function()
		StaticPopup_Show("PKBWIPE_BUTTON")
	end)
	wipebutton:SetScript("OnEnter", function()
		local msg = L["Click to wipe playerslist"]
		PKBlow:CreateTT(wipebutton, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	wipebutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local filterbutton = locDB.calls.api.createframe("Button", "PKBOptionsFilterButton", PKBpanel, "UIPanelButtonTemplate")
	filterbutton:SetWidth(125)
	filterbutton:SetHeight(30)
	filterbutton:SetPoint("TOPLEFT",PKBpanel, 280, -355)
	filterbutton:SetText(L["NPC-Filter"])
	filterbutton:SetScript("OnClick", function()
		StaticPopup_Show("PKBFILTER_BUTTON")
	end)
	filterbutton:SetScript("OnEnter", function()
		local msg = L["Click to add a NPC to the NPC-Filter.|nEnter the npc's name in the popup editbox."]
		PKBlow:CreateTT(filterbutton, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	filterbutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local reloadbutton = locDB.calls.api.createframe("Button", "PKBOptionsReloadButton", uipanel, "UIPanelButtonTemplate")
	reloadbutton:SetWidth(125)
	reloadbutton:SetHeight(30)
	reloadbutton:SetPoint("TOPLEFT", uipanel, 160, -440)
	reloadbutton:SetText("ReloadUI")
	reloadbutton:SetScript("OnClick", function()
		ReloadUI()
	end)
	reloadbutton:SetScript("OnEnter", function()
		local msg = L["To keep the functionality of PKBlow,|nit's recommended to reload the interface|nafter customizing the PKBlow window."]
		PKBlow:CreateTT(reloadbutton, "ANCHOR_RIGHT", 10, -30, msg)
	end)
	reloadbutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local custchatbutton = locDB.calls.api.createframe("Button", "PKBOptionsCustChatButton", kbchatpanel, "UIPanelButtonTemplate")
	custchatbutton:SetWidth(145)
	custchatbutton:SetHeight(30)
	custchatbutton:SetPoint("TOPLEFT", kbchatpanel, 280, -122)
	custchatbutton:SetText("Custom chat msg")
	custchatbutton:SetScript("OnClick", function()
		StaticPopup_Show("PKBCUSTCHATMSG_BUTTON")
	end)
	custchatbutton:SetScript("OnEnter", function()
		local msg = "Create a custom message,|nthese tokens can be used anywhere in your message:|n<myname>, <myserver>, <nmename>, <nmeserver>, <curkills>, <totkills>, <killspree>.|nExample: <myname> killed <nmename>-<nmeserver> <curkills> x, killing spree = <killspree>.|nIn my case this would result in: Pakze killed fubar-dentarg 3 x, killingspree = 5."
		PKBlow:CreateTT(custchatbutton, "ANCHOR_BOTTOM", 10, -30, msg)
	end)
	custchatbutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local custemotebutton = locDB.calls.api.createframe("Button", "PKBCustEmotesButton", emotepanel, "UIPanelButtonTemplate")
	custemotebutton:SetWidth(125)
	custemotebutton:SetHeight(30)
	custemotebutton:SetPoint("TOPLEFT", emotepanel, 200, -122)
	custemotebutton:SetText("Custom emote")
	custemotebutton:SetScript("OnClick", function()
		StaticPopup_Show("PKBEMOTE_BUTTON")
	end)
	custemotebutton:SetScript("OnEnter", function()
		local msg = "Make your own custom emotes.|nThese emotes act like the /e command."
		PKBlow:CreateTT(custemotebutton, "ANCHOR_TOP", 10, 0, msg)
	end)
	custemotebutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local delemotebutton = locDB.calls.api.createframe("Button", "PKBDeleteEmotesButton", emotepanel, "UIPanelButtonTemplate")
	delemotebutton:SetWidth(125)
	delemotebutton:SetHeight(30)
	delemotebutton:SetPoint("TOPLEFT", emotepanel, 350, -122)
	delemotebutton:SetText("Delete emote")
	delemotebutton:SetScript("OnClick", function()
		StaticPopup_Show("PKBDELETEEMOTE_BUTTON")
	end)
	delemotebutton:SetScript("OnEnter", function()
		local msg = "Delete a custom emote"
		PKBlow:CreateTT(delemotebutton, "ANCHOR_TOP", 10, 0, msg)
	end)
	delemotebutton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

	local useremotecheckbtn = locDB.calls.api.createframe("CheckButton", "PKBlow_UserEmoteCheckButton", emotepanel, "ChatConfigCheckButtonTemplate")
	useremotecheckbtn:SetPoint("TOPLEFT", emotepanel, 40, -125)
	PKBlow:SetFontWithFlags("PKBlow_UserEmoteCheckButtonText", "GUI", 12)
	PKBlow_UserEmoteCheckButtonText:SetText(" Use custom emotes")
	if pkbDB.optDB.custemote == 1 then
		useremotecheckbtn:SetChecked(true)
	else
		useremotecheckbtn:SetChecked(false)
	end
	useremotecheckbtn:SetScript("OnClick",function()
		local ischecked = useremotecheckbtn:GetChecked()
		if ischecked == 1 then
			pkbDB.optDB.custemote = 1
		else
			pkbDB.optDB.custemote = 0
		end
	end)
	useremotecheckbtn:SetScript("OnEnter", function()
		local msg = "Using custom emotes will disable blizzard emotes"
		PKBlow:CreateTT(useremotecheckbtn, "ANCHOR_TOP", 10, 0, msg)
	end)
	useremotecheckbtn:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)

 	InterfaceOptions_AddCategory(PKBpanel)
 	InterfaceOptions_AddCategory(uipanel)
	InterfaceOptions_AddCategory(kbchatpanel)
	InterfaceOptions_AddCategory(kbannouncepanel)
 	InterfaceOptions_AddCategory(emotepanel)


end

-----------------------------------------------------------------------------------------------------------------
-----------------------------[[  LDBlauncher  ]]------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------

-- create programm launcher (based on the bugsack LDB code)
function PKBlow:CreateLauncher()

	if LDB then
		PKBlauncher = LDB:NewDataObject("PKBlow", {
			type = "data source",
			icon = "interface\\pvprankbadges\\pvprank14",
			label = addonname,
			text = locDB.fcolor.orangered.h.." "..locDB.kills.totkblows..PKBlow:LdbKillsMsg(),
			value = locDB.fcolor.orangered.h.." "..locDB.kills.totkblows.."|r",
			suffix = PKBlow:LdbKillsMsg(),
			OnClick = function(clickedframe, button)
				local shiftkey = IsShiftKeyDown()
				local altkey = IsAltKeyDown()
				if button == "LeftButton" then
					if shiftkey then
						InterfaceOptionsFrame_OpenToCategory(PKBlow_Panel)
						if PKBlow_Frame then
							if PKBlow_Frame:IsVisible() then
								PKBlow:HideMainFrame()
							end
						end
					elseif altkey then
						local msg = L["Killing blow"]
						PKBKbMessageFrame:EnableMouse(true)
						PKBKbMessageFrame:SetFading(false)
						PKBKbMessageFrame:SetBackdrop({
							bgFile = locDB.ddDB.bg[5][1],
							edgeFile = nil,
							tile = true, tileSize = 16, edgeSize = 16,
							insets = {
								left = 0, right = 0, top = 0, bottom = 0
							}
						})
						PKBKbMessageFrame:AddMessage(msg, locDB.fcolor.orangered.r, locDB.fcolor.orangered.g, locDB.fcolor.orangered.b, 1)
					else
						if not PKBlow_Frame then
							PKBlow:MainGUI()
							PKBlow_Frame:Show()
							if locDB.bool.splayer == true or locDB.bool.getrealm == true then
								PKBlow_Search:SetFocus()
							end
						else
							if PKBlow_Frame:IsVisible() then
								PKBlow:HideMainFrame()
							else
								if locDB.bool.splayer == true or locDB.bool.getrealm == true then
									PKBlow_Search:SetFocus()
								end
								PKBlow_Frame:Show()
								if locDB.bool.splayer == true or locDB.bool.getrealm == true then
									PKBlow_Search:SetFocus()
								end
							end
						end
					end
				elseif button == "RightButton"then
					if altkey then
						local sw = GetScreenWidth() / 2
						local sh = GetScreenHeight() / 2
						local xpos, ypos = PKBKbMessageFrame:GetCenter()
						pkbDB.settingsDB.guiDB.kbmsgfr.xpos = floor((xpos - sw) + 0.5)
						pkbDB.settingsDB.guiDB.kbmsgfr.ypos = floor((ypos - sh) + 0.5)
						PKBKbMessageFrame:EnableMouse(false)
						PKBKbMessageFrame:SetFading(true)
						PKBKbMessageFrame:SetBackdrop(nil)
					end
				end
			end,
			OnLeave = function(self)
				local mx, my = Minimap:GetCenter()
				local px, py = GetCursorPosition()
				local scale = Minimap:GetEffectiveScale()
				px, py = px / scale, py / scale
				pkbDB.ldbDB.minimapicon.minimapPos = math.deg(math.atan2(py - my, px - mx)) % 360
			end,
			OnTooltipShow = function(tt)
				tt:AddLine(locDB.fcolor.orangered.h.."PKBlow|r")
--				tt:AddLine(locDB.fcolor.blzzyellow.h.."_______________________________________________________|r")
				tt:AddLine(" ")
				if pkbDB.optDB.doemote == 1 then
					if pkbDB.optDB.custemote == 1 then
						if #pkbDB.settingsDB.custemotes > 0 and pkbDB.settingsDB.custemotes[1] ~= "No emotes" then
							tt:AddDoubleLine(locDB.fcolor.white.h..CUSTOM.." "..strlower(EMOTE)..":|r", locDB.fcolor.lawngreen..pkbDB.settingsDB.custemotes[1].."|r")
						end
						if #pkbDB.settingsDB.custemotes > 1 then
							for index, value in ipairs(pkbDB.settingsDB.custemotes) do
								if index > 1 then
									tt:AddDoubleLine(" ", locDB.fcolor.lawngreen..pkbDB.settingsDB.custemotes[index].."|r")
								end
							end
						end
					else
						local t = pkbDB.settingsDB.emotestokensDB
						sort(t)
						if #pkbDB.settingsDB.emotestokensDB > 0 then
							tt:AddDoubleLine(locDB.fcolor.white.h..EMOTE..":|r", locDB.fcolor.lawngreen..pkbDB.settingsDB.emotestokensDB[1].."|r")
						end
						if #pkbDB.settingsDB.emotestokensDB > 1 then
							for index, value in ipairs(pkbDB.settingsDB.emotestokensDB) do
								if index > 1 then
									tt:AddDoubleLine(" ", locDB.fcolor.lawngreen..pkbDB.settingsDB.emotestokensDB[index].."|r")
								end
							end
						end
					end
					tt:AddLine(" ")
				end
				tt:AddDoubleLine(locDB.fcolor.white.h..L["Tot KB's"]..": |r", locDB.fcolor.cyan..locDB.kills.totkblows.."|r")
				tt:AddDoubleLine(locDB.fcolor.white.h..L["Cur KB's"]..": |r", locDB.fcolor.red..locDB.kills.kblows.."|r")
				tt:AddLine(" ")
--				tt:AddLine(locDB.fcolor.blzzyellow.h.."_______________________________________________________|r")
				tt:AddDoubleLine(locDB.fcolor.blzzyellow.h..locDB.calls.globstr.keybut1.."|r", locDB.fcolor.lawngreen..L["Open"].."/"..locDB.calls.globstr.close.."|r")
				tt:AddDoubleLine(locDB.fcolor.blzzyellow.h..locDB.calls.globstr.shftkeytxt.." + "..locDB.calls.globstr.keybut1.."|r", locDB.fcolor.lawngreen..locDB.calls.globstr.mmenu.."|r")
				tt:AddDoubleLine(locDB.fcolor.blzzyellow.h..locDB.calls.globstr.altkeytxt.." + "..locDB.calls.globstr.keybut1.."|r", locDB.fcolor.lawngreen.."move KB announce frame|r")
				tt:AddDoubleLine(locDB.fcolor.blzzyellow.h..locDB.calls.globstr.altkeytxt.." + "..locDB.calls.globstr.keybut2.."|r", locDB.fcolor.lawngreen.."lock KB announce frame|r")
			end
		})
		if PKBIcon then
			PKBIcon:Register("PKBlow", PKBlauncher, pkbDB.ldbDB.minimapicon)
		end
	end

end

-----------------------------------------------------------------------------------------------------------------
--------------------------[[  Register events  ]] ---------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------

--  create coreframe to register and watch events
if not PKBCoreFrame then
	locDB.calls.api.createframe("Frame", "PKBCoreFrame", UIParent)
end

local function RegEventsHandler(self, event, ...)

	if event == "PLAYER_LOGIN" then
		PKBlow:PlayerLogin()
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
		local playername = UnitName("player")
		local _, playerclass = UnitClass("player")
		local petname = UnitName("pet")
		local destname = destName
		local destguid = destGUID
		local _, destclass = UnitClass("target")
		local typeflag = bit.band(destFlags, COMBATLOG_OBJECT_TYPE_MASK)
		local isplayer = typeflag == COMBATLOG_OBJECT_TYPE_PLAYER
		local ispet = typeflag == COMBATLOG_OBJECT_TYPE_PET
		local isguardian = typeflag == COMBATLOG_OBJECT_TYPE_GUARDIAN
		local isnpc = typeflag == COMBATLOG_OBJECT_TYPE_NPC
		local isobject = typeflag == COMBATLOG_OBJECT_TYPE_OBJECT
		local overkill = nil
		if type == "RANGE_DAMAGE" or type =="SPELL_DAMAGE" or type == "SWING_DAMAGE" then
			if type == "SWING_DAMAGE" then
				overkill = select(13, ...)
			else
				overkill = select(16, ...)
			end
			if overkill >= 0 then
 				for i = 1, #locDB.petGuid do
					if sourceGUID == locDB.petGuid[i] then
						if isplayer and not (ispet or isguardian or isnpc or isobject) then
							PKBlow:KBHandler(destname, destguid, playername, destclass, playerclass)
						end
					end
 				end
			end
		elseif type == "PARTY_KILL" then
			if sourceName == playername and destName ~= playername then
				if isplayer and not (ispet or isguardian or isnpc or isobject) then
					PKBlow:KBHandler(destname, destguid, playername, destclass, playerclass)
				end
			end
		elseif event == "SPELL_SUMMON" and sourceName == playername then
			local dGuid = destguid
			locDB.petGuid[#locDB.petGuid + 1] = dGuid
		end
	elseif event == "PLAYER_DEAD" or  "PLAYER_ENTERING_BATTLEGROUND" or "PLAYER_ENTERING_WORLD" then
		PKBlow:KillStreakHandler(event)
	end

end

function PKBlow:RegEvents()

	PKBlow.eventHandler = PKBCoreFrame
	PKBlow.eventHandler:RegisterEvent("ADDON_LOADED")
	PKBlow.eventHandler:RegisterEvent("PLAYER_LOGIN")
	PKBlow.eventHandler:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	PKBlow.eventHandler:RegisterEvent("UNIT_PET")
	PKBlow.eventHandler:RegisterEvent("PLAYER_DEAD")
	PKBlow.eventHandler:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND")
	PKBlow.eventHandler:RegisterEvent("PLAYER_ENTERING_WORLD")
	PKBlow.eventHandler:SetScript("OnEvent", RegEventsHandler)

end

PKBlow:RegEvents()
